spool '&1'
prompt
prompt Creating body MD
prompt =========================
prompt
CREATE OR REPLACE PACKAGE MD IS
  TYPE refCursor IS REF CURSOR;

  -- Utilities
  FUNCTION getLangSuffix(parm_locale IN VARCHAR2) RETURN VARCHAR2;

  FUNCTION getEncryptionType RETURN PLS_INTEGER;

  FUNCTION getEncryptionKey RETURN RAW;

  PROCEDURE mdm_get_sequence(parm_table_name IN VARCHAR2,
	returnCursor IN OUT refCursor);

  PROCEDURE mdm_getStats (parm_entity_type IN VARCHAR2,
    parm_stat_location IN VARCHAR2,
    parm_staging_id      IN INTEGER DEFAULT NULL);

  PROCEDURE mdm_log_error(param_table_name IN VARCHAR2 DEFAULT NULL,
	param_service_name IN VARCHAR2 DEFAULT NULL,
	param_record_id IN INTEGER,
	param_record_id_from IN VARCHAR2 DEFAULT NULL,
	param_error_source IN VARCHAR2,
	param_error_code IN VARCHAR2,
	param_error_message IN VARCHAR2,
	param_error_dttm IN TIMESTAMP WITH LOCAL TIME ZONE);

  -- Cluster support
  PROCEDURE stwd_entityCluster_r(parm_cluster_id IN INTEGER,
    parm_entity_type IN VARCHAR2,
    parm_userid IN varchar2,
    retire_dttm TIMESTAMP,
	returnCursor IN OUT refCursor);

  PROCEDURE stwd_updateClusterMapping (parm_cluster_id IN INTEGER,
	parm_new_cluster_id IN INTEGER);

  PROCEDURE stwd_addMemberHistory (parm_old_cluster_id IN INTEGER,
	parm_entity_id IN INTEGER);

  -- Entity support
  PROCEDURE stwd_entity_r(parm_mdm_entity_id IN INTEGER,
  parm_entity_type IN VARCHAR2,
	parm_userid IN varchar2,
	retire_dttm TIMESTAMP);

  PROCEDURE mdm_entity_r(parm_mdm_entity_id IN INTEGER,
  parm_entity_type IN VARCHAR2,
	parm_userid IN VARCHAR2,
	retire_dttm TIMESTAMP,
	returnCursor IN OUT refCursor);
	
  PROCEDURE mdm_findLatestSurvivor(parm_mdm_entity_cluster_id IN INTEGER, parm_entity_type IN VARCHAR2, returnCursor IN OUT refCursor);

  -- Search procedures
  PROCEDURE mdm_search_entity(entityType IN VARCHAR2,
	showRetired IN CHAR,
    roles IN VARCHAR2,
	rowlimit IN INTEGER DEFAULT 100,
	whereClause IN VARCHAR2,
	orderBy IN VARCHAR2,
	ascending IN CHAR,
	returnCursor IN OUT refCursor);

  PROCEDURE mdm_search_relationship(clusterId IN INTEGER,
    relType IN VARCHAR2,
	showRelated IN CHAR,
	showInverse IN CHAR,
    roles IN VARCHAR2,
	rowlimit IN INTEGER DEFAULT 100,
	whereClause IN VARCHAR2,
	returnCursor IN OUT refCursor);

  PROCEDURE mdm_add_relationship(relTypeId IN INTEGER,
    fromClusterId IN INTEGER, toClusterId IN INTEGER, returnCursor IN OUT refCursor);

  PROCEDURE mdm_retire_relationship(relTypeId IN INTEGER,
    fromClusterId IN INTEGER, toClusterId IN INTEGER, returnCursor IN OUT refCursor);

  PROCEDURE mdm_start_process_control(parm_staging_id  IN INTEGER,
    parm_process_name IN VARCHAR2,
	parm_entity_type_id IN INTEGER,
	returnCursor IN OUT refCursor);

  PROCEDURE mdm_end_process_control(parm_process_id IN INTEGER,
	parm_process_success IN VARCHAR2);

  PROCEDURE mdm_addUpdate_forcedCluster(parm_ori_cluster_id IN INTEGER,
	parm_curr_cluster_id IN INTEGER,
	parm_ssid IN INTEGER,
	parm_ssrid IN VARCHAR2,
	parm_entity_type_id IN INTEGER);

  PROCEDURE mdm_get_matchingRows(parm_staging_id IN INTEGER,parm_entity_type IN VARCHAR2, returnCursor IN OUT refCursor);

  PROCEDURE mdm_get_forcedClusterRules(parm_staging_id IN INTEGER,parm_entity_type IN VARCHAR2,returnCursor IN OUT refCursor);

  PROCEDURE mdm_alterStTtTables(parm_entity_type_id IN INTEGER, parm_entity_type IN VARCHAR2, parm_is_abstract IN CHAR);

  PROCEDURE mdm_entityType_goLive(parm_entity_type_id IN INTEGER,
	parm_opseq   IN INTEGER,
	returnCursor IN OUT refCursor);

  PROCEDURE mdm_buildSearchVw(parm_entity_type_id IN INTEGER,parm_entity_type IN VARCHAR2, parm_is_abstract IN CHAR);

  PROCEDURE mdm_entity_golive(firstClusterId in integer,
	lastClusterId in integer,
	parm_staging_id in integer,
	tt_columns in varchar2,
	parm_entity_type in varchar2,
	parm_current_dttm in timestamp,
	parm_userid IN varchar2,
    parm_process_type IN VARCHAR2,
    parm_match_type   IN INTEGER,
    parm_comment IN nvarchar2);

  PROCEDURE mdm_staging_goLive(parm_staging_id IN INTEGER,parm_entity_type_id IN INTEGER,
    increment in INTEGER,parm_userid IN VARCHAR2,
    parm_process_type in VARCHAR2,parm_comment IN NVARCHAR2 DEFAULT NULL,
    returnCursor IN OUT refCursor);

 PROCEDURE mdm_encrypt_value (parm_value IN VARCHAR2,
	returnCursor  IN OUT refCursor);

  PROCEDURE mdm_getDecryptTtCols (parm_entity_type_id IN INTEGER,
	returnCursor  IN OUT refCursor);

  PROCEDURE mdm_decryptCols (parm_entity_type IN VARCHAR2,
	parm_entity_type_id  IN INTEGER,
	parm_tbl_suffix      IN VARCHAR2,
	returnCursor  IN OUT refCursor);

  PROCEDURE mdm_decryptCols_byClusterId (parm_entity_type IN VARCHAR2,
    parm_cluster_id  IN INTEGER,
	parm_tt_columns  IN VARCHAR2,
	parm_tbl_suffix  IN VARCHAR2,
	returnCursor   IN OUT refCursor);

  PROCEDURE mdm_decryptCols_byEntityId (parm_entity_type IN VARCHAR2,
	parm_entity_id  IN INTEGER,
	parm_tt_columns  IN VARCHAR2,
	parm_tbl_suffix  IN VARCHAR2,
	returnCursor   IN OUT refCursor);

  PROCEDURE mdm_getDecryptString (parm_attr_name IN VARCHAR2,
	returnCursor IN OUT refCursor);

  PROCEDURE mdm_queryCluster (parm_entity_type IN VARCHAR2,
	parm_cluster_id IN INTEGER,
	parm_show_retired IN VARCHAR2,
	returnCursor IN OUT refCursor);

  PROCEDURE mdm_getAttrs (parm_entity_type IN VARCHAR2, parm_attr_type IN CHAR, returnCursor IN OUT refCursor);

  PROCEDURE mdm_retireEntityType (parm_entity_type_id IN INTEGER,returnCursor IN OUT refCursor);
  
  PROCEDURE mdm_createColumns (parm_table_name IN VARCHAR2, parm_column_name IN VARCHAR2, parm_datatype IN VARCHAR2,  
    parm_length IN INTEGER, parm_locale IN VARCHAR2);

  PROCEDURE mdm_entityIdExists (parm_entity_type  IN VARCHAR2, parm_entity_id IN INTEGER, returnCursor IN OUT refCursor);
  
  PROCEDURE mdm_dashboardCountsByDate (parm_entity_type IN VARCHAR2, returnCursor IN OUT refCursor);
                                       
  PROCEDURE mdm_dashboardGetActiveRetired (parm_entity_type IN VARCHAR2, parm_curr_dttm  IN TIMESTAMP, parm_active_retired IN VARCHAR2,
    returnCursor IN OUT refCursor);
                                           
  PROCEDURE mdm_batchLoadStats (parm_entity_type IN VARCHAR2, parm_process_id IN INTEGER, returnCursor IN OUT refCursor);
                                
  PROCEDURE mdm_dashboardCountsByStatus (parm_entity_type IN VARCHAR2, returnCursor IN OUT refCursor);                               
                                
  PROCEDURE mdm_dashboardClusterSize (parm_entity_type IN VARCHAR2, returnCursor IN OUT refCursor);
                                      
  PROCEDURE mdm_getClusterHistory (parm_entity_type IN VARCHAR2, parm_cluster_id IN INTEGER, parm_cluster_label IN VARCHAR2,
    returnCursor IN OUT refCursor);
                            
  PROCEDURE mdm_createStagingTables (parm_entity_type_id IN INTEGER, parm_entity_type IN VARCHAR2, parm_staging_id IN INTEGER DEFAULT NULL);

  PROCEDURE mdm_createStagingIndices (parm_entity_type IN VARCHAR2, parm_staging_id IN INTEGER DEFAULT NULL);
                                      
  PROCEDURE mdm_deleteProcessedRecords (parm_entity_type IN VARCHAR2, parm_staging_id IN INTEGER, parm_startCluster IN INTEGER,
    parm_endCluster IN INTEGER, parm_processType IN VARCHAR2, parm_increment IN INTEGER);
    
  PROCEDURE mdm_archive (parm_entity_type IN VARCHAR2, parm_curr_dttm IN TIMESTAMP, parm_action IN VARCHAR2, returnCursor IN OUT refCursor);
  
  PROCEDURE mdm_alterTtIndices (parm_entity_type IN VARCHAR2, parm_index_option IN VARCHAR2);
END MD;
/
show errors
/

prompt
prompt Creating package body MD
prompt =========================
prompt
CREATE OR REPLACE PACKAGE BODY MD IS

  FUNCTION getLangSuffix(parm_locale IN VARCHAR2) RETURN VARCHAR2
  AS
    lang_cd         VARCHAR2(50);
    is_default_lang CHAR(1);
  BEGIN
    IF (parm_locale IS NULL) THEN
      lang_cd := '';
      RETURN(lang_cd);
    END IF;

    SELECT mdm_qkb_locale,mdm_is_default INTO lang_cd, is_default_lang
    FROM mdm_languages
    WHERE MDM_QKB_LOCALE = parm_locale;

    IF (is_default_lang = 'Y') THEN
        lang_cd := '';
    ELSE
        lang_cd := '_'||trim(lang_cd);
    END IF;

    RETURN(lang_cd);

  EXCEPTION
    WHEN NO_DATA_FOUND THEN
      ROLLBACK;
      md.mdm_log_error('getLangSuffix - no data found for locale ['||parm_locale||']',null,0,null,'getLangSuffix('||parm_locale||')',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000 - SQLCODE,'getLangSuffix - no data found for locale ['||parm_locale||']');
    WHEN OTHERS THEN
      ROLLBACK;
      md.mdm_log_error('getLangSuffix',null,0,null,parm_locale,SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000 + SQLCODE,SQLERRM);
  END;

  FUNCTION getEncryptionType RETURN PLS_INTEGER AS
  BEGIN
    RETURN dbms_crypto.des_cbc_pkcs5;
  END;

  FUNCTION getEncryptionKey RETURN RAW AS

  key      RAW(2000);

  BEGIN
    SELECT mdm_encryption_key
      INTO key
      FROM mdm_secure.mdm_secure_info;

    RETURN key;
  EXCEPTION
    WHEN OTHERS THEN
      ROLLBACK;
      md.mdm_log_error('getEncryptionKey',null,0,null,null,SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000 + SQLCODE,SQLERRM);
  END;

  PROCEDURE mdm_log_error(param_table_name IN VARCHAR2 DEFAULT NULL,
	param_service_name IN VARCHAR2 DEFAULT NULL,
	param_record_id IN INTEGER,
	param_record_id_from IN VARCHAR2 DEFAULT NULL,
	param_error_source IN VARCHAR2,
	param_error_code IN VARCHAR2,
	param_error_message IN VARCHAR2,
	param_error_dttm IN TIMESTAMP WITH LOCAL TIME ZONE)
  AS
  pragma autonomous_transaction;
  BEGIN
    INSERT INTO MDM_ERROR_LOG(TABLE_NAME,SERVICE_NAME,RECORD_ID,RECORD_ID_FROM,ERROR_SOURCE,ERROR_CODE,ERROR_MESSAGE,ERROR_DATE)
    VALUES(param_table_name,param_service_name,param_record_id,param_record_id_from,param_error_source,param_error_code,param_error_message,param_error_dttm);
    COMMIT;
  EXCEPTION
    WHEN OTHERS THEN
      ROLLBACK;
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_get_sequence(parm_table_name IN VARCHAR2,
	returnCursor IN OUT refCursor)
  AS
  BEGIN
    OPEN returnCursor FOR 'SELECT ' || parm_table_name ||'_SEQ.NEXTVAL as seq_curr_val FROM dual';
  EXCEPTION
    WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error('SEQUENCES',null,0,null,'df_sequence_util',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_getStats (parm_entity_type IN VARCHAR2,
                          parm_stat_location IN VARCHAR2,
                          parm_staging_id      IN INTEGER DEFAULT NULL)
    AS
    table_name  VARCHAR2(50);
    entitySt_tbl VARCHAR2(50);
    stg_tbl      VARCHAR2(50);
    audit_table VARCHAR2(50);
  BEGIN
    IF (parm_staging_id IS NULL) THEN
      entitySt_tbl := 'MDM_'||parm_entity_type||'_ST';
      stg_tbl := 'MDM_STAGING';
    ELSE
      entitySt_tbl := 'MDM_BULK_ST_'||parm_staging_id;
      stg_tbl := 'MDM_STAGING_'||parm_staging_id;
    END IF;
    
    IF (parm_stat_location = 'POST_CLUSTER') THEN
      DBMS_STATS.gather_table_stats(ownname => user,tabname => entitySt_tbl,estimate_percent => DBMS_STATS.AUTO_SAMPLE_SIZE,method_opt => 'for all indexed columns', cascade => true);
      DBMS_STATS.gather_table_stats(ownname => user,tabname => stg_tbl,estimate_percent => DBMS_STATS.AUTO_SAMPLE_SIZE,method_opt => 'for all indexed columns', cascade => true);
    END IF;

    table_name:='MDM_'||parm_entity_type||'_TT';
    audit_table:='MDM_'||parm_entity_type||'_AL';
    IF (parm_stat_location = 'POST_LIVE') THEN
      DBMS_STATS.gather_table_stats(ownname => user,tabname => 'MDM_ENTITY_CLUSTERS',estimate_percent => DBMS_STATS.AUTO_SAMPLE_SIZE,method_opt => 'for all indexed columns', cascade => true);
      DBMS_STATS.gather_table_stats(ownname => user,tabname => audit_table,estimate_percent => DBMS_STATS.AUTO_SAMPLE_SIZE,method_opt => 'for all indexed columns', cascade => true);
      DBMS_STATS.gather_table_stats(ownname => user,tabname => table_name,estimate_percent => DBMS_STATS.AUTO_SAMPLE_SIZE,method_opt => 'for all indexed columns', cascade => true);
    END IF;
  EXCEPTION
    WHEN OTHERS THEN
      mdm_log_error(table_name,null,null,null,'mdm_getStats',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

PROCEDURE stwd_entity_r(parm_mdm_entity_id IN INTEGER,
  parm_entity_type IN VARCHAR2,
	parm_userid IN varchar2,
	retire_dttm TIMESTAMP)
  AS
    strSql VARCHAR2(500); 
    tbl_nm VARCHAR2(50);   
  BEGIN
    tbl_nm := 'MDM_'||parm_entity_type||'_TT';
    strSql := 'UPDATE '||tbl_nm||'
                  SET mdm_valid_to_dttm = :1
                WHERE mdm_entity_id = :2';
    EXECUTE IMMEDIATE strSql USING retire_dttm,parm_mdm_entity_id;
    
    IF SQL%ROWCOUNT > 0 THEN
      tbl_nm := 'MDM_'||parm_entity_type||'_AL';
      strSql := 'INSERT INTO '||tbl_nm||' (TABLE_NAME,RECORD_ID,USER_ACTION,MDM_MODIFIED_BY,MODIFIED_DTTM)
                    VALUES (''MDM_'||parm_entity_type||'_TT'',:1,''RETIRE'',:2,:3)';
      EXECUTE IMMEDIATE strSql USING parm_mdm_entity_id,parm_userid,retire_dttm; 
    END IF;
  EXCEPTION
    WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error(tbl_nm,null,parm_mdm_entity_id,'mdm_entity_id','stwd_entity_r',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

   PROCEDURE stwd_entityCluster_r(parm_cluster_id IN INTEGER,
      parm_entity_type IN VARCHAR2,
      parm_userid IN VARCHAR2,
      retire_dttm TIMESTAMP,
	  returnCursor IN OUT refCursor)
  AS
    cluster_count INTEGER;
    tbl_nm VARCHAR2(50);
    actual_retire_dttm DATE;
    strSql  VARCHAR2(500);
  BEGIN

    tbl_nm := 'MDM_'||parm_entity_type||'_TT';
    
    -- Check first -- if the cluster has already been retired, then return 'N'
    -- indicating that we did not retire the cluster this time
    strSql := 'SELECT count(1)FROM '||tbl_nm||'
                WHERE mdm_entity_cluster_id = :1
                  AND (mdm_valid_to_dttm IS NULL OR mdm_valid_to_dttm > :2)';
    EXECUTE IMMEDIATE strSql INTO cluster_count USING parm_cluster_id,retire_dttm;           
        
    IF cluster_count = 0 THEN      
      strSql := 'SELECT MAX(mdm_valid_to_dttm) FROM '||tbl_nm||'
                  WHERE mdm_entity_cluster_id = :1';   
      EXECUTE IMMEDIATE strSql INTO actual_retire_dttm USING parm_cluster_id;
    
      OPEN returnCursor FOR SELECT actual_retire_dttm AS retire_date FROM sys.dual;
      RETURN;
    END IF;    

    strSql := 'UPDATE '||tbl_nm||'
                  SET mdm_valid_to_dttm = :1
                WHERE mdm_entity_cluster_id = :2
                  AND (mdm_valid_to_dttm IS NULL OR mdm_valid_to_dttm > :3)';
    EXECUTE IMMEDIATE strSql USING retire_dttm,parm_cluster_id,retire_dttm;
    
    tbl_nm := 'MDM_'||parm_entity_type||'_AL';
    IF SQL%ROWCOUNT > 0 THEN
      strSql := 'INSERT INTO '||tbl_nm||' (TABLE_NAME,RECORD_ID,USER_ACTION,MDM_MODIFIED_BY,MODIFIED_DTTM)
                   SELECT ''MDM_'||parm_entity_type||'_TT'',mdm_entity_id,''RETIRE'',:1,:2
                     FROM mdm_'||parm_entity_type||'_tt
                    WHERE mdm_entity_cluster_id = :3
                      AND mdm_valid_to_dttm = :4';
      EXECUTE IMMEDIATE strSql USING parm_userid,retire_dttm,parm_cluster_id,retire_dttm;
    END IF;

    tbl_nm := 'MDM_FORCED_CLUSTERS';

    UPDATE mdm_forced_clusters
       SET original_cluster_id = -1
     WHERE original_cluster_id = parm_cluster_id;

    UPDATE mdm_forced_clusters
       SET current_cluster_id = -1
     WHERE current_cluster_id = parm_cluster_id;

     tbl_nm := 'MDM_ENTITY_REL';

     UPDATE mdm_entity_rel
        SET mdm_valid_to_dttm = retire_dttm
      WHERE (mdm_from_cluster_id = parm_cluster_id OR mdm_to_cluster_id = parm_cluster_id);

  EXCEPTION
    WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error(tbl_nm,null,parm_cluster_id,'mdm_entity_cluster_id','stwd_entityCluster_r',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_search_entity(entityType IN VARCHAR2,
	showRetired IN CHAR,
    roles IN VARCHAR2,
	rowlimit IN INTEGER DEFAULT 100,
	whereClause IN VARCHAR2,
	orderBy IN VARCHAR2,
	ascending IN CHAR,
	returnCursor IN OUT refCursor)
 AS
    searchSql varchar2(10000);
    dataMaskingSql varchar2(2000);
    iRowLimit integer;
    searchView varchar2(50);
    mdm_error_messages VARCHAR2(1000);
    entityTypeId integer;
    isAbstract char(1);
    noConcreteSubclass integer;
    tt_columns varchar2(4000);
    raw_columns varchar2(4000);
    retiredWhereClause varchar2(200);
    retiredSurvivorClause varchar2(200);
    ascendingClause varchar2(10);
    label_id integer;
    attr_id integer;
    attr_name varchar2(30);

    NO_CONCRETE_SUBCLASSES EXCEPTION;
    TYPE tt_cursor IS REF CURSOR;
    tt_curs tt_cursor;
    raw_curs tt_cursor;

  BEGIN
    iRowLimit := rowlimit;
    IF (iRowLimit IS NULL) THEN
      iRowLimit := 100;
    END IF;

    SELECT mdm_entity_type_id, mdm_abstract INTO entityTypeId, isAbstract FROM mdm_entity_types WHERE lower(mdm_entity_type) = lower(entityType);

    IF (isAbstract = 'Y') THEN
      select count(1) into noConcreteSubclass from mdm_entity_types
      where mdm_entity_type_id <> entityTypeId
        and (mdm_valid_to_dttm is null or mdm_valid_to_dttm > systimestamp)
        and mdm_golive_dttm is not null
        and mdm_abstract='N'
      start with mdm_entity_type_id=entityTypeId
      connect by prior mdm_entity_type_id=mdm_parent_id;
      IF (noConcreteSubclass = 0) THEN
        RAISE NO_CONCRETE_SUBCLASSES;
      END IF;
    END IF;

    mdm_getDecryptTtCols(entityTypeId,tt_curs);
    FETCH tt_curs INTO tt_columns;

    -- Build raw column string
    mdm_getAttrs(entityType,'D',raw_curs);
    raw_columns:='';
    LOOP
      FETCH raw_curs INTO attr_id,attr_name;
      EXIT WHEN raw_curs%NOTFOUND;
      IF (attr_id > 0) THEN
          raw_columns:=raw_columns||','||attr_name;
      END IF;
    END LOOP;

    select mdm_label_attr_id into label_id from mdm_entity_types 
    where mdm_label_attr_id is not null
      and mdm_entity_type_id in
       (select mdm_entity_type_id from mdm_entity_types
        where mdm_valid_to_dttm is null
        start with mdm_entity_type_id=entityTypeId
        connect by prior mdm_entity_type_id=mdm_parent_id
        union
        select mdm_entity_type_id from mdm_entity_types
        where mdm_entity_type_id <> entityTypeId and mdm_valid_to_dttm is null
        start with mdm_entity_type_id=entityTypeId
        connect by mdm_entity_type_id=prior mdm_parent_id);

    dataMaskingSql := 'select x.mdm_entity_type_id from
      (
      select er.mdm_entity_type_id from mdm_entity_type_access er
      where lower(er.mdm_group) in ('||lower(roles)||') and er.mdm_active = ''Y''
      union
      select et.mdm_entity_type_id from mdm_entity_types et
        where et.mdm_entity_type_id not in
         (select mdm_entity_type_id from mdm_entity_type_access where mdm_active = ''Y'')
      ) x
      inner join mdm_entity_types et on et.mdm_entity_type_id=x.mdm_entity_type_id and et.mdm_valid_to_dttm is null
      where x.mdm_entity_type_id not in (select mdm_entity_type_id from MDM_ATTR_ACCESS at where mdm_attr_id='||label_id||' and lower(at.MDM_GROUP) not in ('||lower(roles)||') and at.MDM_ACTIVE=''Y'')';

    IF (showRetired = 'N') THEN
      retiredWhereClause:='  and mdm_valid_to_dttm is null ';
      retiredSurvivorClause:=' mdm_valid_to_dttm is null ';
    else
      retiredWhereClause:=' ';
      retiredSurvivorClause:=' (mdm_valid_to_dttm is null or mdm_valid_to_dttm = max_valid_to_dttm) ';
    end if;

    IF (ascending = 'Y') THEN
      ascendingClause:=' asc ';
    else
      ascendingClause:=' desc ';
    end if;

    searchSql:='select mdm_entity_type_id,mdm_entity_cluster_id,mdm_entity_id,mdm_src_sys_id,mdm_src_sys_rec_id,mdm_language_id,mdm_valid_from_dttm,mdm_valid_to_dttm'|| raw_columns||',ROWNUM rnum from 
        (
        select mdm_entity_type_id,mdm_entity_cluster_id,mdm_entity_id,mdm_src_sys_id,mdm_src_sys_rec_id,mdm_language_id,mdm_valid_from_dttm,mdm_valid_to_dttm'|| tt_columns||'
        from mdm_'||entityType||'_sv
        where mdm_entity_cluster_id in (select distinct mdm_entity_cluster_id from mdm_'||entityType||'_sv where '||whereClause||retiredWhereClause||')
          and '||retiredSurvivorClause||' and mdm_src_sys_id=1
          and mdm_entity_type_id in ('||dataMaskingSql||')
        order by '||orderBy||ascendingClause||'
        )
          where rownum <= :1';
    OPEN returnCursor FOR searchSql using iRowLimit;
  EXCEPTION
    WHEN NO_CONCRETE_SUBCLASSES THEN
      mdm_error_messages := 'This Entity Type has no concrete subclasses to search.';
      mdm_log_error(searchView ,null,0,null,'df_transpose_search_util',SQLCODE,mdm_error_messages,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,mdm_error_messages);
    WHEN OTHERS THEN
      ROLLBACK;
      searchView := 'mdm_'||entityType||'_sv';
      mdm_error_messages := SQLERRM||'|'||entityType||'|'||whereClause||'|';
      mdm_log_error(searchView ,null,0,null,'df_transpose_search_util',SQLCODE,mdm_error_messages,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,mdm_error_messages);
  END;

  PROCEDURE mdm_search_relationship(clusterId IN INTEGER,
    relType IN VARCHAR2,
	showRelated IN CHAR,
	showInverse IN CHAR,
    roles IN VARCHAR2,
	rowlimit IN INTEGER DEFAULT 100,
	whereClause IN VARCHAR2,
	returnCursor IN OUT refCursor)
  AS
    searchSql varchar2(20000);
    matchSql varchar2(4000);
    authoredRelSql varchar2(400);
    retiredRelSql varchar2(400);
    dataMaskingSql varchar2(2000);
    mdm_error_messages VARCHAR2(1000);
    iRowLimit integer;
    srcEntityType varchar2(23);
    tgtEntityType varchar2(23);
    srcEntityTypeId integer;
    tgtEntityTypeId integer;
    srcIsAbstract char(1);
    tgtIsAbstract char(1);
    isAbstract char(1);
    searchEntityType varchar2(23);
    searchTargetType varchar2(23);
    searchEntityTypeid integer;
    relTypeId integer;
    noConcreteSubclass integer;
    tt_columns varchar2(4000);
    conditionId integer;
    prevConditionId integer;
    srcAttr varchar2(30);
    tgtAttr varchar2(30);
    subjectAttr varchar2(30);
    objectAttr varchar2(30);
    TYPE tt_cursor IS REF CURSOR;
    tt_curs tt_cursor;
    CURSOR get_conditions IS select c.mdm_entity_rel_condition_id,fr_attr.mdm_attr_name as from_attr,to_attr.mdm_attr_name as to_attr
      from mdm_entity_rel_conditions c
      inner join mdm_attrs fr_attr on c.mdm_from_attr_id=fr_attr.mdm_attr_id
      inner join mdm_attrs to_attr on c.mdm_to_attr_id=to_attr.mdm_attr_id
      where mdm_entity_rel_type_id=relTypeId
      order by mdm_entity_rel_condition_id;
    NO_CONCRETE_SUBCLASSES EXCEPTION;
  BEGIN
    iRowLimit := rowlimit;
    IF (iRowLimit IS NULL) THEN
      iRowLimit := 100;
    END IF;

    -- Turn the relationship type into entity type information
    select rt.mdm_rel_type_id,fr_et.mdm_entity_type as from_entity_type,rt.mdm_from_entity_type_id,fr_et.mdm_abstract as from_abstract,
      to_et.mdm_entity_type as to_entity_type,rt.mdm_to_entity_type_id,to_et.mdm_abstract as to_abstract
    into relTypeId,srcEntityType,srcEntityTypeId,srcIsAbstract,tgtEntityType,tgtEntityTypeId,tgtIsAbstract
    from mdm_entity_rel_types rt
    inner join mdm_entity_types fr_et on rt.mdm_from_entity_type_id=fr_et.mdm_entity_type_id
    inner join mdm_entity_types to_et on rt.mdm_to_entity_type_id=to_et.mdm_entity_type_id
    where lower(relType)=lower(rt.mdm_rel_type)
      and rt.mdm_valid_from_dttm <=systimestamp and (rt.mdm_valid_to_dttm is null or rt.mdm_valid_to_dttm > systimestamp);

    IF (showInverse = 'N') THEN
      searchEntityType:=tgtEntityType;
      searchTargetType:=srcEntityType;
      searchEntityTypeId:=tgtEntityTypeId;
      isAbstract:=tgtIsAbstract;
      authoredRelSql:='select mdm_to_cluster_id from mdm_entity_rel where mdm_entity_rel_type_id=:1 and mdm_from_cluster_id=:2
        and (mdm_valid_to_dttm is null or mdm_valid_to_dttm > systimestamp)';
      retiredRelSql:='select mdm_to_cluster_id from mdm_entity_rel where mdm_entity_rel_type_id=:3 and mdm_from_cluster_id=:4
        and mdm_valid_to_dttm <= systimestamp';
    ELSE
      searchEntityType:=srcEntityType;
      searchTargetType:=tgtEntityType;
      searchEntityTypeId:=srcEntityTypeId;
      isAbstract:=srcIsAbstract;
      authoredRelSql:='select mdm_from_cluster_id from mdm_entity_rel where mdm_entity_rel_type_id=:1 and mdm_to_cluster_id=:2
        and (mdm_valid_to_dttm is null or mdm_valid_to_dttm > systimestamp)';
      retiredRelSql:='select mdm_from_cluster_id from mdm_entity_rel where mdm_entity_rel_type_id=:3 and mdm_to_cluster_id=:4
        and mdm_valid_to_dttm <= systimestamp';
    END IF;

    -- make sure the entity type is actually searchable
    IF (isAbstract = 'Y') THEN
      select count(1) into noConcreteSubclass from mdm_entity_types
      where mdm_entity_type_id <> searchEntityTypeId
        and (mdm_valid_to_dttm is null or mdm_valid_to_dttm > systimestamp)
        and mdm_golive_dttm is not null
        and mdm_abstract='N'
      start with mdm_entity_type_id=searchEntityTypeId
      connect by prior mdm_entity_type_id=mdm_parent_id;
      IF (noConcreteSubclass = 0) THEN
        RAISE NO_CONCRETE_SUBCLASSES;
      END IF;
    END IF;

    IF (showRelated='Y') THEN
      matchSQL:='';
      OPEN get_conditions;
      LOOP
        FETCH get_conditions into conditionId,srcAttr,tgtAttr;
        EXIT WHEN get_conditions%NOTFOUND;
        IF (showInverse = 'N') THEN
          subjectAttr:=tgtAttr;
          objectAttr:=srcAttr;
        ELSE
          subjectAttr:=srcAttr;
          objectAttr:=tgtAttr;
        END IF;
        IF (prevConditionId is null) THEN
          matchSql:='';
        ELSE
          IF (prevConditionId <> conditionId) THEN
            matchSql:=matchSql||' OR ';
          ELSE
            matchSql:=matchSQL||' AND ';
          END IF;
        END IF;
        matchSql := matchSql||subjectAttr||' in (select distinct '||objectAttr||' from mdm_'||searchTargetType||'_sv where mdm_entity_cluster_id='|| clusterId
          ||' and mdm_src_sys_id > 1 and (mdm_valid_to_dttm is null  or mdm_valid_to_dttm > systimestamp))';
        prevConditionId := conditionId;
      END LOOP;
      -- no conditions? then we can't return any results. Make the where clause shut everything down.
      IF (matchSql is null or length(ltrim(rtrim(matchSql))) = 0) THEN
        matchSql:='1=2';
      END IF;
      CLOSE get_conditions;
    ELSE
      authoredRelSql:='select 0 as mdm_entity_cluster_id from dual where 0=:1 and 0=:2';
      retiredRelSql:='select 0 as mdm_entity_cluster_id from dual where 0=:1 and 0=:2';
      -- We might not have a whereclause. If so, default to a tautology
      IF ((whereClause IS NULL) OR (length(ltrim(rtrim(whereClause)))) = 0) THEN
        matchSql:='1=1';
      ELSE
        matchSql:=whereClause;
      END IF;
    END IF;

    -- Get the columns for the entity type
    mdm_getDecryptTtCols(searchEntityTypeId,tt_curs);
    FETCH tt_curs INTO tt_columns;

    dataMaskingSql := 'select er.mdm_entity_type_id from mdm_entity_type_access er
      where lower(er.mdm_group) in ('||lower(roles)||') and er.mdm_active = ''Y''
      union
      select et.mdm_entity_type_id from mdm_entity_types et
      where et.mdm_entity_type_id not in
         (select mdm_entity_type_id from mdm_entity_type_access where mdm_active = ''Y'')';

    searchSql:='select mdm_entity_type_id,mdm_entity_cluster_id,mdm_entity_id,mdm_src_sys_id,mdm_src_sys_rec_id,mdm_language_id,mdm_valid_from_dttm,mdm_valid_to_dttm'|| tt_columns||'
      from mdm_'||searchEntityType||'_sv
      where mdm_entity_cluster_id in
       (select distinct mdm_entity_cluster_id from (select distinct mdm_entity_cluster_id from mdm_'||searchEntityType||'_sv
        where (mdm_valid_to_dttm is null or mdm_valid_to_dttm >systimestamp) and '||matchSql||' union '||authoredRelSql||'))
          and mdm_entity_cluster_id not in ('|| retiredRelSql||')
          and mdm_valid_from_dttm < systimestamp
          and (mdm_valid_to_dttm is null or mdm_valid_to_dttm > systimestamp)
          and mdm_src_sys_id=1
          and mdm_entity_type_id in ('||dataMaskingSql||')
          and rownum <= :5
      order by mdm_entity_cluster_id';

    OPEN returnCursor FOR searchSql using relTypeId,clusterId,relTypeId,clusterId,iRowLimit;
  EXCEPTION
    WHEN NO_CONCRETE_SUBCLASSES THEN
      mdm_error_messages := 'This Entity Type has no concrete subclasses to search.';
      mdm_log_error(relType,null,0,null,'mdm_search_relationship',SQLCODE,mdm_error_messages,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,mdm_error_messages);
    WHEN OTHERS THEN
      ROLLBACK;
      mdm_error_messages := SQLERRM||'|'||relType||'|'||whereClause||'|';
      mdm_log_error(relType ,null,0,null,'mdm_search_relationship',SQLCODE,mdm_error_messages,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,mdm_error_messages);
  END;

  PROCEDURE mdm_add_relationship(relTypeId IN INTEGER,
    fromClusterId IN INTEGER, toClusterId IN INTEGER, returnCursor IN OUT refCursor)
  AS
    active_dttm TIMESTAMP;
  BEGIN
	insert into mdm_entity_rel (mdm_entity_rel_type_id,mdm_from_cluster_id,mdm_to_cluster_id)
	values (relTypeId,fromClusterId,toClusterId)
	returning mdm_valid_from_dttm INTO active_dttm;
    OPEN returnCursor FOR SELECT active_dttm as mdm_valid_from_dttm FROM sys.dual;
  EXCEPTION
    WHEN DUP_VAL_ON_INDEX then
      -- if it was retired, unretire it.
      update mdm_entity_rel set mdm_valid_to_dttm=null,mdm_valid_from_dttm=systimestamp where MDM_ENTITY_REL_TYPE_ID=relTypeId
        and MDM_FROM_CLUSTER_ID=fromClusterId and MDM_TO_CLUSTER_ID=toClusterId
        and MDM_VALID_TO_DTTM <=systimestamp;
      OPEN returnCursor FOR SELECT mdm_valid_from_dttm FROM mdm_entity_rel where MDM_ENTITY_REL_TYPE_ID=relTypeId
         and MDM_FROM_CLUSTER_ID=fromClusterId and MDM_TO_CLUSTER_ID=toClusterId;
    WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error('MDM_ENTITY_REL',null,relTypeId,'relTypeId','mdm_add_relationship',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_retire_relationship(relTypeId IN INTEGER,
    fromClusterId IN INTEGER, toClusterId IN INTEGER, returnCursor IN OUT refCursor)
  AS
    retire_dttm TIMESTAMP WITH LOCAL TIME ZONE;
  BEGIN	
	retire_dttm:=sysdate;
	merge into mdm_entity_rel r
      using (select relTypeId as relTypeId,fromClusterId as fromClusterId,toClusterId as toClusterId from dual) contr
      on (r.MDM_ENTITY_REL_TYPE_ID=contr.relTypeId and r.MDM_FROM_CLUSTER_ID=contr.fromClusterId and r.MDM_TO_CLUSTER_ID=contr.toClusterId)
      when matched then update set r.mdm_valid_to_dttm=retire_dttm
      when not matched then
        insert (MDM_ENTITY_REL_TYPE_ID,MDM_FROM_CLUSTER_ID,MDM_TO_CLUSTER_ID,MDM_VALID_FROM_DTTM,MDM_VALID_TO_DTTM)
        values (contr.relTypeId,contr.fromClusterId,contr.toClusterId,systimestamp,retire_dttm);
   OPEN returnCursor FOR SELECT mdm_valid_to_dttm FROM mdm_entity_rel
     where mdm_entity_rel_type_id=relTypeId and mdm_from_cluster_id=fromClusterId and mdm_to_cluster_id=toClusterId;
  EXCEPTION
    WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error('MDM_ENTITY_REL',null,relTypeId,'relTypeId','mdm_retire_relationship',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_entity_r(parm_mdm_entity_id IN INTEGER,
  parm_entity_type IN VARCHAR2,
	parm_userid IN varchar2,
	retire_dttm TIMESTAMP,
	returnCursor IN OUT refCursor)
  AS
    cluster_id  INTEGER;
    is_survivor CHAR(1);
    active_contributors INTEGER;
    actual_retire_dttm DATE;
    target_dttm DATE;
    strSql  VARCHAR2(500);
  BEGIN
	IF (retire_dttm IS NULL) THEN
      target_dttm := sysdate;
    ELSE
       target_dttm:=retire_dttm;
    END IF;

    -- Check first: if the entity has already been retired, then return retired date
    strSql := 'SELECT mdm_valid_to_dttm FROM mdm_'||parm_entity_type||'_tt
                WHERE mdm_entity_id = :1';
    EXECUTE IMMEDIATE strSql INTO actual_retire_dttm USING parm_mdm_entity_id;
    
    IF (actual_retire_dttm IS NULL OR actual_retire_dttm > target_dttm) THEN
       strSql := 'SELECT mdm_entity_cluster_id,mdm_survivor
                    FROM mdm_'||parm_entity_type||'_tt
                   WHERE mdm_entity_id = :1';
       EXECUTE IMMEDIATE strSql INTO cluster_id,is_survivor USING parm_mdm_entity_id;
       
       strSql := 'SELECT count(1) FROM mdm_'||parm_entity_type||'_tt
                   WHERE mdm_entity_cluster_id = :1
                     AND mdm_survivor = ''N''
                     AND mdm_valid_from_dttm <= :2
                     AND (mdm_valid_to_dttm IS NULL OR mdm_valid_to_dttm > :3)';
       EXECUTE IMMEDIATE strSql INTO active_contributors USING cluster_id,target_dttm,target_dttm;
       
       IF (is_survivor = 'Y') or (active_contributors <= 1) THEN
          stwd_entityCluster_r(cluster_id, parm_entity_type, parm_userid, target_dttm, returnCursor);
       ELSE
          stwd_entity_r(parm_mdm_entity_id, parm_entity_type, parm_userid, target_dttm);
       END IF;

       actual_retire_dttm := target_dttm;
    END IF;

    OPEN returnCursor FOR SELECT actual_retire_dttm AS retire_date FROM sys.dual;

  EXCEPTION
    WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error(null,null,parm_mdm_entity_id,'mdm_entity_id','mdm_entity_r',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_findLatestSurvivor(parm_mdm_entity_cluster_id IN INTEGER,parm_entity_type IN VARCHAR2, returnCursor IN OUT refCursor) AS
  
  sqlStr  varchar(1000);
  
  BEGIN
    sqlStr := 'select mdm_entity_id as entity_id from
        (select mdm_entity_id,mdm_valid_to_dttm,
          max(nvl(mdm_valid_to_dttm,TO_DATE(''31.12.9999 23:59:59'', ''dd.mm.yyyy hh24:mi:ss'')))
          over (partition by mdm_entity_cluster_id) max_valid_to_dttm
      from mdm_'||parm_entity_type||'_tt where mdm_survivor=''Y'' and mdm_entity_cluster_id=:1) t
    where mdm_valid_to_dttm is null or mdm_valid_to_dttm=max_valid_to_dttm';
    
    OPEN returnCursor FOR sqlStr using parm_mdm_entity_cluster_id;
      
  EXCEPTION
    WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error('MDM_'||parm_entity_type||'TT',null,0,null,'mdm_findLatestSurvivor',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_start_process_control(parm_staging_id  IN INTEGER,
  parm_process_name IN VARCHAR2,
	parm_entity_type_id IN INTEGER,
	returnCursor IN OUT refCursor)
  AS
    ret_process_id INTEGER;
  BEGIN
    INSERT INTO mdm_process_control (mdm_staging_id, process_name, mdm_entity_type_id, process_running, process_start_dttm)
    VALUES (parm_staging_id, parm_process_name, parm_entity_type_id, 'Y', systimestamp)
    RETURNING process_id INTO ret_process_id;
    OPEN returnCursor FOR SELECT ret_process_id AS process_id FROM dual;
  EXCEPTION
    WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error('MDM_PROCESS_CONTROL',null,0,null,'mdm_start_process_control',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_end_process_control(parm_process_id IN INTEGER, parm_process_success IN VARCHAR2) AS
  BEGIN
    UPDATE mdm_process_control SET process_running = 'N', process_success = parm_process_success, process_end_dttm = systimestamp
    WHERE process_id = parm_process_id;
  EXCEPTION
    WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error('MDM_PROCESS_CONTROL',null,0,null,'mdm_end_process_control',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE stwd_updateClusterMapping (parm_cluster_id IN INTEGER,parm_new_cluster_id IN INTEGER) AS
  BEGIN
     UPDATE mdm_cluster_mapping SET current_cluster_id = parm_new_cluster_id
     WHERE original_cluster_id = parm_cluster_id;
  EXCEPTION
    WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error('MDM_CLUSTER_MAPPING',null,0,null,'mdm_updateClusterMapping',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE stwd_addMemberHistory (parm_old_cluster_id IN INTEGER,
	parm_entity_id IN INTEGER)
  AS
  BEGIN
    INSERT INTO mdm_cluster_member_history (mdm_entity_cluster_id, mdm_entity_id,mdm_modified_dttm)
    VALUES (parm_old_cluster_id,parm_entity_id,systimestamp);
  EXCEPTION
    WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error('MDM_CLUSTER_MEMBER_HISTORY',null,0,null,'stwd_addMemberHistory',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_addUpdate_forcedCluster(parm_ori_cluster_id IN INTEGER,
	parm_curr_cluster_id IN INTEGER,
	parm_ssid IN INTEGER,
	parm_ssrid IN VARCHAR2,
	parm_entity_type_id IN INTEGER)
  AS
    record_exists INTEGER;
    old_curr_cluster INTEGER;
    cluster_id_exists INTEGER;
  BEGIN
    SELECT count(1) INTO record_exists FROM mdm_forced_clusters
    WHERE src_sys_id = parm_ssid
      AND src_sys_rec_id = parm_ssrid
      AND entity_type_id = parm_entity_type_id;

    IF (record_exists > 0) THEN
      SELECT current_cluster_id INTO old_curr_cluster
       FROM mdm_forced_clusters
      WHERE src_sys_id = parm_ssid
        AND src_sys_rec_id = parm_ssrid
        AND entity_type_id = parm_entity_type_id;

      UPDATE mdm_forced_clusters SET current_cluster_id = parm_curr_cluster_id
       WHERE src_sys_id = parm_ssid
         AND src_sys_rec_id = parm_ssrid
         AND entity_type_id = parm_entity_type_id;

      SELECT count(1) INTO cluster_id_exists FROM mdm_forced_clusters
       WHERE current_cluster_id = old_curr_cluster;

      IF (cluster_id_exists = 0) THEN
         UPDATE mdm_entity_clusters SET mdm_cluster_type = 'N'
          WHERE mdm_entity_cluster_id = old_curr_cluster;
      END IF;
    ELSE
      INSERT INTO mdm_forced_clusters (original_cluster_id, src_sys_id,src_sys_rec_id,entity_type_id,current_cluster_id)
      VALUES (parm_ori_cluster_id,parm_ssid,parm_ssrid,parm_entity_type_id,parm_curr_cluster_id);
    END IF;

    UPDATE mdm_entity_clusters SET mdm_cluster_type = 'F'
     WHERE mdm_entity_cluster_id = parm_curr_cluster_id;

  EXCEPTION
    WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error('MDM_FORCED_CLUSTERS',null,0,null,'mdm_addUpdate_forcedCluster',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_get_matchingRows(parm_staging_id IN INTEGER,
	                               parm_entity_type IN VARCHAR2,
	                               returnCursor IN OUT refCursor)
  AS
    sql_str           VARCHAR2(12000);
    conditionStr      VARCHAR2(1500);
    conditionId       INTEGER;
    attrName          VARCHAR2(50);
    encryptFlag       CHAR(1);
    parentId          INTEGER;
    tt_columns        VARCHAR2(4000);
    isFirstCondition  BOOLEAN;
    isNewCondition    BOOLEAN;
    prevCondition INTEGER;
    entityTypeId  INTEGER;
    entityCc_tbl  VARCHAR2(30);
    CURSOR get_attrs IS
      SELECT mdm_attr_name, mdm_encrypt_flag,mdm_parent_attr_id FROM mdm_attrs
       WHERE mdm_entity_type_id IN (SELECT mdm_entity_type_id FROM mdm_entity_types
                                     WHERE (mdm_valid_to_dttm > systimestamp or mdm_valid_to_dttm is null)
                                    START WITH LOWER(mdm_entity_type) = LOWER(parm_entity_type)
                                    CONNECT BY PRIOR mdm_parent_id = mdm_entity_type_id)
         AND mdm_valid_from_dttm < systimestamp AND (mdm_valid_to_dttm is null or mdm_valid_to_dttm > systimestamp)
         AND mdm_attr_id > 0;
    CURSOR get_clusterConditions IS SELECT mdm_cluster_condition_id, mdm_attr_name
             FROM mdm_cluster_condition_vw
            WHERE mdm_entity_type_id IN (SELECT mdm_entity_type_id
                                           FROM mdm_entity_types
                                          WHERE (mdm_valid_to_dttm IS NULL OR mdm_valid_to_dttm > systimestamp) AND mdm_golive_dttm IS NOT NULL
                                     START WITH LOWER(mdm_entity_type) = LOWER(parm_entity_type) CONNECT BY PRIOR mdm_parent_id=mdm_entity_type_id)
          ORDER BY mdm_cluster_condition_id;
  BEGIN
    entityCc_tbl := 'MDM_BULK_CC_'||parm_staging_id;
    
    -- Get entity type id
    SELECT mdm_entity_type_id INTO entityTypeId FROM mdm_entity_types
     WHERE lower(mdm_entity_type)=lower(parm_entity_type);

    -- Build columns string
    tt_columns:='';

    OPEN get_attrs;
    LOOP
      fetch get_attrs into attrName,encryptFlag,parentId;
      EXIT WHEN get_attrs%NOTFOUND;
      IF (encryptFlag = 'Y' AND parentId IS NULL) THEN
         tt_columns:=tt_columns||',utl_raw.cast_to_varchar2(dbms_crypto.decrypt('||attrName||',md.getEncryptionType,md.getEncryptionKey)) as '||attrName;
      ELSE
         tt_columns:=tt_columns||','||attrName;
      END IF;
    END LOOP;
    CLOSE get_attrs;

    -- Build cluster condition string
    conditionStr := '';
    isFirstCondition := true;

    OPEN get_clusterConditions;
      LOOP
        FETCH get_clusterConditions into conditionId,attrName;
        EXIT WHEN get_clusterConditions%NOTFOUND;
          IF (prevCondition = conditionId) THEN
              isNewCondition := false;
          ELSE
              isNewCondition := true;
          END IF;

          IF (isFirstCondition) THEN
              isFirstCondition := false;
              conditionStr := conditionStr||' (';
          ELSE IF (isNewCondition) THEN
                   conditionStr := conditionStr||') OR (';
               ELSE
                   conditionStr := conditionStr||' AND ';
               END IF;
          END IF;

          conditionStr := conditionStr||'s.'||attrName||'=ma.'||attrName;
          prevCondition := conditionId;
      END LOOP;
      conditionStr := conditionStr||')';
    CLOSE get_clusterConditions;

    -- Get rows
    sql_str := 'SELECT fv.original_cluster_id, fv.current_cluster_id,ma1.mdm_entity_type_id,ma1.mdm_entity_id,ma1.mdm_src_sys_id,
              ma1.mdm_src_sys_rec_id,ma1.mdm_language_id,ma1.mdm_valid_from_dttm,ma1.mdm_valid_to_dttm,ma1.mdm_entity_cluster_id,
              ma1.mdm_survivor'||tt_columns||'
         FROM mdm_'||parm_entity_type||'_ma ma1
         LEFT OUTER JOIN mdm_forced_clusters fv ON fv.src_sys_id = ma1.mdm_src_sys_id AND fv.src_sys_rec_id = ma1.mdm_src_sys_rec_id AND fv.entity_type_id = :1
        WHERE mdm_entity_cluster_id IN (SELECT ma.mdm_entity_cluster_id
                          FROM mdm_'||parm_entity_type||'_tt ma,'||entityCc_tbl||' s
                           WHERE '||conditionStr||')';
    OPEN returnCursor FOR sql_str USING entityTypeId;
  EXCEPTION
    WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error('MDM_GET_MATCHINGROWS',null,0,null,'mdm_get_matchingRows',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_get_forcedClusterRules(parm_staging_id IN INTEGER,
	                                     parm_entity_type IN VARCHAR2,
	                                     returnCursor IN OUT refCursor) AS
  sql_str           VARCHAR2(12000);
  entity_type_id    INTEGER;

  BEGIN
    -- Get entity type id
    SELECT mdm_entity_type_id INTO entity_type_id FROM mdm_entity_types
     WHERE lower(mdm_entity_type)=lower(parm_entity_type);

   --Get Rows
   sql_str := 'select st.mdm_src_sys_id,st.mdm_src_sys_rec_id,fc.original_cluster_id,fc.current_cluster_id '||
                'from mdm_'||parm_entity_type||'_cc st '||
            'left join (select * from mdm_forced_clusters where entity_type_id = :1) fc '||
              'on st.mdm_src_sys_id = fc.src_sys_id and st.mdm_src_sys_rec_id = fc.src_sys_rec_id '||
             'where st.mdm_staging_id =:2';

    OPEN returnCursor FOR sql_str USING entity_type_id,parm_staging_id;

  EXCEPTION
    WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error('MDM_GET_FORCEDCLUSTERRULES',null,parm_staging_id,'mdm_staging_id','mdm_get_forcedClusterRules',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_alterStTtTables(parm_entity_type_id IN INTEGER,
                                parm_entity_type IN VARCHAR2,
                                parm_is_abstract IN CHAR) AS
    num_rows integer;
    attr_id integer;
    attr_name varchar2(50);
    attr_datatype varchar2(50);
    attr_nullable varchar2(10);
    attr_defn varchar2(100);
    attr_length integer;
    attr_encrypt char(1);
    parent_id integer;
    changeFlag integer;
    db_datatype varchar2(50);
    tt_name varchar2(50);
    strSql varchar2(32000);
    view_name varchar2(50);
    CURSOR get_attrs IS select a.mdm_attr_id,a.mdm_attr_name,a.mdm_attr_length,a.mdm_encrypt_flag,a.mdm_parent_attr_id,t.mdm_db_datatype,
      case
        when (t.mdm_db_datatype='VARCHAR2' OR t.mdm_db_datatype='NVARCHAR2') then t.mdm_db_datatype||'('||case when a.mdm_attr_length>0 then a.mdm_attr_length else 1 end||')'
        else t.mdm_db_datatype end as datatype,
      case
        when a.mdm_required='Y' or  
		a.mdm_attr_id in 
			(select mdm_label_attr_id from mdm_entity_types
                                       where ((mdm_valid_to_dttm > systimestamp or mdm_valid_to_dttm is null) and mdm_label_attr_id IS NOT NULL)
                                       start with mdm_entity_type_id = parm_entity_type_id
                                       connect by prior mdm_parent_id = mdm_entity_type_id)
		then 'NOT NULL'
        else 'NULL'end as nullable
      from mdm_attrs a, mdm_attr_datatypes t
      where a.mdm_attr_id > 0 and a.mdm_attr_datatype_id=t.mdm_attr_datatype_id
        and a.mdm_entity_type_id in (select mdm_entity_type_id from mdm_entity_types
                                       where (mdm_valid_to_dttm > systimestamp or mdm_valid_to_dttm is null)
                                       start with mdm_entity_type_id = parm_entity_type_id
                                       connect by prior mdm_parent_id = mdm_entity_type_id)
        and (a.mdm_valid_from_dttm is null or a.mdm_valid_from_dttm <= systimestamp)
        and (a.mdm_valid_to_dttm > systimestamp or a.mdm_valid_to_dttm is null)
     order by a.mdm_attr_name;

  BEGIN
    tt_name := 'MDM_' || parm_entity_type || '_TT';

    -- Add columnns
    OPEN get_attrs;
    LOOP
      FETCH get_attrs into attr_id,attr_name,attr_length, attr_encrypt, parent_id,db_datatype, attr_datatype, attr_nullable;
      EXIT WHEN get_attrs%NOTFOUND;

      IF (parm_is_abstract = 'N') THEN
          select count(1) INTO num_rows from user_tab_columns where lower(column_name) = lower(attr_name) and lower(table_name) = lower(tt_name);

          if (attr_encrypt = 'Y' and parent_id is null) then
            attr_datatype := 'RAW(1000)';
          end if;

          attr_defn:=upper(attr_name)||' '||attr_datatype||' '||attr_nullable;

          if (num_rows=0) THEN
            changeFlag:=1;
            strSQL:='ALTER TABLE '||tt_name||' ADD '||attr_defn;
            EXECUTE IMMEDIATE strSQL;
            update mdm_attrs set mdm_valid_from_dttm=systimestamp where mdm_attr_id=attr_id and mdm_valid_from_dttm is null;
          END IF;
      END IF;
    END LOOP;
    CLOSE get_attrs;

    -- Create Staging Tables
    IF (parm_is_abstract = 'N') THEN
        mdm_createStagingTables(parm_entity_type_id, parm_entity_type);
        mdm_createStagingIndices(parm_entity_type);
    END IF;

    -- Build views
    IF (changeFlag > 0) OR (parm_is_abstract='Y') THEN
      IF (parm_is_abstract='N') THEN
        view_name := 'MDM_' || parm_entity_type || '_MA';
        strSQL := 'CREATE OR REPLACE VIEW ' || view_name || ' AS
          SELECT  T.*,ET.MDM_ENTITY_TYPE_ID
          FROM ' || tt_name || ' T
          INNER JOIN MDM_ENTITY_TYPES ET ON LOWER(ET.MDM_ENTITY_TYPE) = LOWER('''||parm_entity_type||''')
          WHERE T.MDM_SURVIVOR = ''N''
            AND T.MDM_VALID_FROM_DTTM <= systimestamp AND (T.MDM_VALID_TO_DTTM > systimestamp OR T.MDM_VALID_TO_DTTM IS NULL)';
        EXECUTE IMMEDIATE strSQL;

        view_name := 'MDM_' || parm_entity_type || '_CV';
        strSQL := 'CREATE OR REPLACE VIEW ' || view_name || ' AS
          SELECT  T.*,ET.MDM_ENTITY_TYPE_ID
          FROM ' || tt_name || ' T
          INNER JOIN MDM_ENTITY_TYPES ET ON LOWER(ET.MDM_ENTITY_TYPE) = LOWER('''||parm_entity_type||''')
          WHERE T.MDM_VALID_FROM_DTTM <= systimestamp AND (T.MDM_VALID_TO_DTTM > systimestamp OR T.MDM_VALID_TO_DTTM IS NULL)';
        EXECUTE IMMEDIATE strSQL;
      END IF;
        mdm_buildSearchVw(parm_entity_type_id,parm_entity_type,parm_is_abstract);
    END IF;
  EXCEPTION
    WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error('MDM_ENTITY_TYPES',null,parm_entity_type_id,'mdm_entity_type_id','mdm_alterStTtTables',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_entityType_goLive(parm_entity_type_id IN INTEGER,
    parm_opseq   IN INTEGER,
    returnCursor IN OUT refCursor)
  AS
    tt_name varchar2(50);
    sv_name varchar2(50);
    al_name varchar2(50);
    num_rows integer;
    changeFlag integer;
    isAbstract CHAR;
    mdm_entity_type varchar2(23);
    opseq integer;
    parent_type_id integer;
    parent_type varchar2(30);
    isParentAbstract char(1);
    childId integer;
    childType varchar2(23);
    isChildAbstract char(1);
    err_location integer;
    err_msg  varchar2(500);
    OUT_OF_DATE EXCEPTION;
    CURSOR get_parentClasses IS select mdm_entity_type_id,mdm_entity_type,mdm_abstract
      from mdm_entity_types
      where mdm_entity_type_id <> parm_entity_type_id and (mdm_valid_to_dttm is null or mdm_valid_to_dttm > systimestamp) and mdm_golive_dttm is not null
      start with mdm_entity_type_id=parm_entity_type_id connect by prior mdm_parent_id=mdm_entity_type_id;
    CURSOR get_subClasses IS select mdm_entity_type_id,mdm_entity_type,mdm_abstract
      from mdm_entity_types
      where (mdm_valid_to_dttm is null or mdm_valid_to_dttm > systimestamp) and mdm_golive_dttm is not null
      start with mdm_entity_type_id=parm_entity_type_id connect by prior mdm_entity_type_id=mdm_parent_id
      order by mdm_abstract;
  BEGIN
    err_location:= 10;
    -- make sure we have an entity type to process.
    SELECT upper(t.mdm_entity_type), mdm_abstract, mdm_opseq into mdm_entity_type, isAbstract, opseq from mdm_entity_types t where t.mdm_entity_type_id=parm_entity_type_id;
    IF (mdm_entity_type IS NULL) THEN
        RAISE_APPLICATION_ERROR(-20000 - SQLCODE,'Could not make '''||parm_entity_type_id||''' live; the entity type is not defined');
        RETURN;
    END IF;

    IF (parm_opseq <> opseq) THEN
        RAISE OUT_OF_DATE;
    END IF;

    -- keep track of the change status; if there's no change, we don't have to reconstruct the views
    changeFlag :=0;
    err_location:= 20;
    -- The entity type may be abstract; test the search view for existence.
    sv_name := 'MDM_' || mdm_entity_type || '_SV';
    EXECUTE IMMEDIATE 'select count(1) from USER_VIEWS where view_name = :sv_name' INTO num_rows USING sv_name;
    IF (num_rows = 0) THEN
      changeFlag := 1;
    END IF;

    -- Only create staging and transpose tables if the entity type is concrete.
    IF (isAbstract = 'N') THEN
      -- if the transpose table doesn't already exist, create it.
      tt_name := 'MDM_' || mdm_entity_type || '_TT';
      al_name := 'MDM_' || mdm_entity_type || '_AL';

      err_location:= 30;
      EXECUTE IMMEDIATE 'select count(1) from USER_TABLES where table_name = :tt_name' INTO num_rows USING tt_name;
      IF (num_rows = 0) THEN
        changeFlag := 1;
        err_location:= 31;
        EXECUTE IMMEDIATE 'CREATE TABLE ' || tt_name || ' (
          MDM_STAGING_ID INTEGER NOT NULL,
          MDM_ENTITY_ID INTEGER NOT NULL,
          MDM_SRC_SYS_ID INTEGER NOT NULL,
          MDM_SRC_SYS_REC_ID  NVARCHAR2(200),
          MDM_LANGUAGE_ID INTEGER NOT NULL,
          MDM_ENTITY_CLUSTER_ID INTEGER NOT NULL,
          MDM_SURVIVOR CHAR(1) NOT NULL,
          MDM_VALID_FROM_DTTM TIMESTAMP WITH LOCAL TIME ZONE NOT NULL,
          MDM_VALID_TO_DTTM TIMESTAMP WITH LOCAL TIME ZONE)';
        err_location:= 32;
        EXECUTE IMMEDIATE 'ALTER TABLE ' || tt_name || ' ADD CONSTRAINT PK_'||mdm_entity_type||'_TT
                         PRIMARY KEY (MDM_ENTITY_ID)';
        err_location:= 33;
        EXECUTE IMMEDIATE 'ALTER TABLE ' || tt_name || ' ADD CONSTRAINT FKL_'||mdm_entity_type||'_TT
          FOREIGN KEY (MDM_LANGUAGE_ID) REFERENCES MDM_LANGUAGES(MDM_LANGUAGE_ID)';        
      END IF;

      -- if the augit log doesn't already exist, create it.
      EXECUTE IMMEDIATE 'select count(1) from USER_TABLES where table_name = :al_name' INTO num_rows USING al_name;
      IF (num_rows = 0) THEN
        changeFlag := 1;
        EXECUTE IMMEDIATE 'CREATE TABLE ' || al_name || '(
          MDM_AUDIT_LOG_ID INTEGER NOT NULL,
          TABLE_NAME       VARCHAR2(50) NOT NULL,
          RECORD_ID        INTEGER NOT NULL,
          USER_ACTION	     VARCHAR2(10) NOT NULL,
          MDM_MODIFIED_BY  NVARCHAR2(513) NOT NULL,
          MODIFIED_DTTM    TIMESTAMP WITH LOCAL TIME ZONE NOT NULL)';
        EXECUTE IMMEDIATE 'ALTER TABLE '||al_name||' ADD CONSTRAINT PK_'||mdm_entity_type||'_AL PRIMARY KEY (MDM_AUDIT_LOG_ID)';
        EXECUTE IMMEDIATE 'CREATE INDEX AL_' || mdm_entity_type || '_RID ON ' || al_name || ' (RECORD_ID)';
        EXECUTE IMMEDIATE 'CREATE OR REPLACE TRIGGER mdm_'||mdm_entity_type||'_al_bi '||
                             'BEFORE INSERT ON '||al_name||' '||
                             'FOR EACH ROW '||
                          'BEGIN '||
                             'IF :new.mdm_audit_log_id IS NULL OR :new.mdm_audit_log_id=0 THEN '||
                                'SELECT mdm_audit_log_seq.nextval INTO :new.mdm_audit_log_id FROM dual; '||
                             'END IF; '||
                          'END  mdm_'||mdm_entity_type||'_al_bi;';
      END IF;

      -- Add attribute columns and build views
      mdm_alterStTtTables(parm_entity_type_id, mdm_entity_type, isAbstract);
    ELSE
      OPEN get_subClasses;
        LOOP
          FETCH get_subClasses INTO childId,childType,isChildAbstract;
          EXIT WHEN get_subClasses%NOTFOUND;
            -- Add attribute columns and build views for children
            mdm_alterStTtTables(childId, childType, isChildAbstract);
        END LOOP;
      CLOSE get_subClasses;
    END IF;
    err_location:= 50;
    UPDATE mdm_entity_types SET mdm_golive_dttm=systimestamp,
      mdm_valid_from_dttm=CASE WHEN mdm_valid_from_dttm IS NULL THEN systimestamp ELSE mdm_valid_from_dttm END
    WHERE mdm_entity_type_id=parm_entity_type_id;

    UPDATE mdm_attrs SET
      mdm_valid_from_dttm=CASE WHEN mdm_valid_from_dttm IS NULL THEN systimestamp ELSE mdm_valid_from_dttm END
    WHERE mdm_entity_type_id=parm_entity_type_id;

    -- Create parent search views
    OPEN get_parentClasses;
      LOOP
        FETCH get_parentClasses INTO parent_type_id,parent_type,isParentAbstract;
        EXIT WHEN get_parentClasses%NOTFOUND;
          mdm_buildSearchVw(parent_type_id,parent_type,isParentAbstract);
      END LOOP;
    CLOSE get_parentClasses;

    if (changeFlag=0) then
      OPEN returnCursor FOR select mdm_golive_dttm as pubDate, mdm_valid_from_dttm, mdm_last_mod_dttm, 'No changes found' as message from mdm_entity_types where mdm_entity_type_id=parm_entity_type_id;
    else
      OPEN returnCursor FOR select mdm_golive_dttm as pubDate,mdm_valid_from_dttm,mdm_last_mod_dttm, 'Changes applied' as message from mdm_entity_types where mdm_entity_type_id=parm_entity_type_id;
    end if;

  EXCEPTION
    WHEN OUT_OF_DATE THEN
      mdm_log_error('MDM_ENTITY_TYPES',null,0,'mdm_entity_type_id','mdm_entityType_goLive',0,'Entity Type Out of Date',systimestamp);
      RAISE_APPLICATION_ERROR(-20000,'Entity Type Out of Date');
    WHEN OTHERS THEN
      ROLLBACK;
      err_msg:= err_location||':'||SQLERRM;
      mdm_log_error('MDM_ENTITY_TYPES',null,0,'mdm_entity_type_id','mdm_entityType_goLive',SQLCODE,err_msg,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_buildSearchVw(parm_entity_type_id IN INTEGER,
                              parm_entity_type    IN VARCHAR2,
                              parm_is_abstract   IN CHAR)
  AS
    firstSubclass  INTEGER;
    strSQL         VARCHAR2(32000);
    subclassViewName  VARCHAR2(50);
    isAbstractSubclass CHAR(1);
    sv_name   VARCHAR2(50);
    tt_columns VARCHAR2(4000);
    attr_id INTEGER;
    attr_name VARCHAR2(50);
    actualEntityTypeId INTEGER;
    TYPE tt_cursor IS REF CURSOR;
    tt_curs tt_cursor;
    CURSOR get_subclasses IS select 'MDM_'||mdm_entity_type||'_TT',mdm_abstract,mdm_entity_type_id
      from mdm_entity_types
      where mdm_entity_type_id <> parm_entity_type_id and mdm_valid_to_dttm is null and mdm_golive_dttm is not null
      start with mdm_entity_type_id=parm_entity_type_id connect by prior mdm_entity_type_id=mdm_parent_id;
  BEGIN

    sv_name := 'MDM_' || parm_entity_type || '_SV';

    -- Build column string
    mdm_getAttrs(parm_entity_type,'D',tt_curs);
    tt_columns:=',MDM_SURVIVOR';
    LOOP
      FETCH tt_curs INTO attr_id,attr_name;
      EXIT WHEN tt_curs%NOTFOUND;
      IF (lower(attr_name) <> lower('MDM_ENTITY_TYPE_ID')) THEN
          tt_columns:=tt_columns||','||attr_name;
      END IF;
    END LOOP;

    firstSubclass:=0;

    -- Create intial view string
    strSQL := 'create or replace view '|| sv_name || ' AS ';
    IF (parm_is_abstract = 'N') THEN
        strSQL := strSQL ||'select max(nvl(mdm_valid_to_dttm,TO_TIMESTAMP_TZ(''31.12.9999 23:59:59'', ''dd.mm.yyyy hh24:mi:ss''))) over (partition by mdm_entity_cluster_id) max_valid_to_dttm,'||parm_entity_type_id||' as mdm_entity_type_id'||tt_columns
              ||' from MDM_' || parm_entity_type || '_TT ' ;
    END IF;

    -- Append subsequent subclass union strings
    OPEN get_subclasses;
    LOOP
      FETCH get_subclasses into subclassViewName,isAbstractSubclass,actualEntityTypeId;
      EXIT WHEN get_subclasses%NOTFOUND;
      IF (isAbstractSubclass='N') THEN
        IF (firstSubclass > 0) THEN
          strSQL := strSQL||' union ';
        ELSE
          firstSubclass:=1;
          IF (parm_is_abstract = 'N') THEN
            strSQL := strSQL||' union ';
          END IF;
        END IF;
        strSQL := strSQL ||'select max(nvl(mdm_valid_to_dttm,TO_TIMESTAMP_TZ(''31.12.9999 23:59:59'', ''dd.mm.yyyy hh24:mi:ss''))) over (partition by mdm_entity_cluster_id) max_valid_to_dttm,'||actualEntityTypeId||' as mdm_entity_type_id'||tt_columns
          ||' from '||subclassViewName||' ';
      END IF;
    END LOOP;
    CLOSE get_subclasses;
    IF (firstSubclass > 0) OR (parm_is_abstract = 'N') THEN
      EXECUTE IMMEDIATE strSQL;
    END IF;

  EXCEPTION
    WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error('MDM_ENTITY_TYPES',null,0,'mdm_entity_type_id','mdm_buildSearchVw',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_staging_goLive(parm_staging_id IN INTEGER,parm_entity_type_id IN INTEGER, increment in INTEGER,parm_userid IN VARCHAR2,parm_process_type in VARCHAR2,parm_comment IN NVARCHAR2 DEFAULT NULL,
	returnCursor IN OUT refCursor)
  AS
    parm_current_dttm TIMESTAMP;
    parm_entity_type varchar2(23);
    CURSOR get_attrs IS
      SELECT mdm_attr_name FROM mdm_attrs
       WHERE mdm_entity_type_id IN (SELECT mdm_entity_type_id FROM mdm_entity_types
                                     WHERE (mdm_valid_to_dttm > parm_current_dttm or mdm_valid_to_dttm is null)
                                    START WITH mdm_entity_type_id = parm_entity_type_id
                                    CONNECT BY PRIOR mdm_parent_id = mdm_entity_type_id)
         AND mdm_valid_from_dttm < parm_current_dttm AND (mdm_valid_to_dttm IS NULL OR mdm_valid_to_dttm > parm_current_dttm)
         AND mdm_attr_id > 0;
    tt_columns varchar2(4000);
    attr_name varchar2(50);
    TYPE cluster_id_rec IS RECORD (cluster_id INTEGER);
    TYPE cluster_id_tbl IS TABLE OF cluster_id_rec;
    tbl_cluster_0 cluster_id_tbl;
    tbl_cluster_1 cluster_id_tbl;
    strSQL varchar2(8000);
    firstIdx integer;
    lastIdx integer;
    err_location integer;
    err_message varchar2(200);
    ret_process_id integer;
    startCluster  integer;
    endCluster    integer;
    clusterStgTbl VARCHAR2(30);
    stgTbl        VARCHAR2(30);
    entityStgTbl  VARCHAR2(30);
    entityCcTbl   VARCHAR2(30);
    num_rows      INTEGER;
    isInitialLoad CHAR(1);
    
  BEGIN
    --mdm_log_error('MDM_STAGING_GOLIVE',null,0,'mdm_entity_id','mdm_entity_goLive',SQLCODE,'Starting staging id : '||parm_staging_id,systimestamp);
    err_location := 10;
    -- Get entity type and timestamp information
    select systimestamp into parm_current_dttm from dual;

    INSERT INTO mdm_process_control (mdm_staging_id, process_name, mdm_entity_type_id, process_running, process_user, process_start_dttm)
    VALUES (parm_staging_id, 'MAKE DATA LIVE', parm_entity_type_id, 'Y', parm_userid, systimestamp)
    RETURNING process_id INTO ret_process_id;

    err_location := 20;
    select mdm_entity_type into parm_entity_type from mdm_entity_types
      where mdm_entity_type_id=parm_entity_type_id and mdm_valid_from_dttm < parm_current_dttm
        and (mdm_valid_to_dttm is null or mdm_valid_to_dttm > parm_current_dttm);
    if parm_entity_type is null then
      RAISE_APPLICATION_ERROR(-20000,'Entity Type Id '||parm_entity_type_id||' does not exist or is not active');
      return;
    end if;

    -- construct a column list for the associated entity type. This list will be concatenated with other columns,
    -- so the leading comma is required.
    -- Using a cursor here because the set is small, and this proc is executed relatively infrequently.
    open get_attrs;
    LOOP
      fetch get_attrs into attr_name;
      EXIT WHEN get_attrs%NOTFOUND;
      tt_columns:=tt_columns||','||attr_name;
    END LOOP;
    close get_attrs;

    err_location := 30;
    IF (lower(parm_process_type) = lower('BULK')) THEN
      clusterStgTbl := 'MDM_BULK_CS_'||parm_staging_id;
      stgTbl := 'MDM_STAGING_'||parm_staging_id;
      entityStgTbl := 'MDM_BULK_ST_'||parm_staging_id;
      entityCcTbl := 'MDM_BULK_CC_'||parm_staging_id;

      EXECUTE IMMEDIATE 'SELECT COUNT(1) FROM user_tables WHERE table_name = :1' INTO num_rows USING clusterStgTbl;
      IF (num_rows > 0) THEN
        EXECUTE IMMEDIATE 'DROP TABLE '||clusterStgTbl;
      END IF;

	    strSQL := 'CREATE TABLE '||clusterStgTbl||' AS
                 SELECT mdm_staging_id,cid,mdm_entity_cluster_seq.nextval as mdm_entity_cluster_id
	                 FROM (SELECT DISTINCT mdm_staging_id, cid
	                         FROM '||entityStgTbl||'
	                        WHERE mdm_staging_id = '||parm_staging_id||'
	                          AND match_type = 0)';
	    EXECUTE IMMEDIATE strSQL;
      EXECUTE IMMEDIATE 'ALTER TABLE '||clusterStgTbl||' ADD CONSTRAINT PK_CLUSTER_STAGING_'||parm_staging_id||'
                              PRIMARY KEY (MDM_STAGING_ID,CID)';
      EXECUTE IMMEDIATE 'CREATE INDEX CST_CLID_'||parm_staging_id||' ON '||clusterStgTbl||' (MDM_ENTITY_CLUSTER_ID)';
      
      mdm_getStats(parm_entity_type,'POST_CLUSTER',parm_staging_id);      
    ELSE
      stgTbl := 'MDM_STAGING';
      entityStgTbl := 'MDM_'||parm_entity_type||'_ST';
    END IF;

    --mdm_log_error('MDM_STAGING_GOLIVE',null,0,'mdm_entity_id','mdm_entity_goLive',SQLCODE,'Assigned new cluster Ids : '||parm_staging_id,systimestamp);

    err_location := 40;
    -- Load the clusters for the staging set
    IF (lower(parm_process_type) = lower('BULK')) THEN
        strSQL := 'SELECT mdm_entity_cluster_id FROM '||clusterStgTbl||' ORDER BY mdm_entity_cluster_id';
        EXECUTE IMMEDIATE strSQL BULK COLLECT INTO tbl_cluster_0;
    ELSE
        strSQL := 'SELECT DISTINCT mdm_entity_cluster_id FROM '||entityStgTbl||'
                    WHERE mdm_staging_id = :1 AND match_type = 0 ORDER BY mdm_entity_cluster_id';
        EXECUTE IMMEDIATE strSQL BULK COLLECT INTO tbl_cluster_0 USING parm_staging_id;
    END IF;

    strSQL := 'SELECT DISTINCT mdm_entity_cluster_id FROM '||entityStgTbl||'
                    WHERE mdm_staging_id = :1 AND match_type > 0 ORDER BY mdm_entity_cluster_id';
    EXECUTE IMMEDIATE strSQL BULK COLLECT INTO tbl_cluster_1 USING parm_staging_id;

    --mdm_log_error('MDM_STAGING_GOLIVE',null,0,'mdm_entity_id','mdm_entity_goLive',SQLCODE,'Loaded cluster ids for processing : '||parm_staging_id,systimestamp);

    err_location := 45;
    EXECUTE IMMEDIATE 'SELECT COUNT(1) FROM MDM_'||parm_entity_type||'_TT' INTO num_rows;
    IF (num_rows = 0) AND (lower(parm_process_type) = lower('BULK')) THEN
      isInitialLoad := 'Y';
      mdm_alterTtIndices(parm_entity_type,'UNUSABLE');
    ELSE
      isInitialLoad := 'N';
    END IF;
    
    err_location := 50;
    -- Iterate over existing clusters
    firstIdx:=1;
    lastIdx:=firstIdx+increment;
    IF (lastIdx > tbl_cluster_1.COUNT) THEN
      lastIdx:=tbl_cluster_1.COUNT;
    END IF;
    WHILE (firstIdx <= tbl_cluster_1.COUNT) LOOP
      IF (firstIdx=1) THEN
        startCluster:=tbl_cluster_1(firstIdx).cluster_id;
      END IF;
      mdm_entity_golive(tbl_cluster_1(firstIdx).cluster_id, tbl_cluster_1(lastIdx).cluster_id,
          parm_staging_id,tt_columns,parm_entity_type,parm_current_dttm,parm_userid,parm_process_type,1,parm_comment);
      endCluster:=tbl_cluster_1(lastIdx).cluster_id;
      IF (firstIdx=1) AND (lower(parm_process_type) = lower('BULK')) THEN
        mdm_getStats(parm_entity_type,'POST_LIVE');
      END IF;
      firstIdx:=lastIdx+1;
      lastIdx:=firstIdx+increment;
      IF (lastIdx > tbl_cluster_1.COUNT) THEN
        lastIdx:=tbl_cluster_1.COUNT;
      END IF;
    END LOOP;

    -- Iterate over new clusters
    firstIdx:=1;
    lastIdx:=firstIdx+increment;
    IF (lastIdx > tbl_cluster_0.COUNT) THEN
      lastIdx:=tbl_cluster_0.COUNT;
    END IF;
    WHILE (firstIdx <= tbl_cluster_0.COUNT) LOOP
      IF (startCluster IS NULL) AND (firstIdx=1) THEN
        startCluster:=tbl_cluster_0(firstIdx).cluster_id;
      END IF;
      mdm_entity_golive(tbl_cluster_0(firstIdx).cluster_id, tbl_cluster_0(lastIdx).cluster_id,
          parm_staging_id,tt_columns,parm_entity_type,parm_current_dttm,parm_userid,parm_process_type,0,parm_comment);
      endCluster:=tbl_cluster_0(lastIdx).cluster_id;      
      firstIdx:=lastIdx+1;
      lastIdx:=firstIdx+increment;
      IF (lastIdx > tbl_cluster_0.COUNT) THEN
        lastIdx:=tbl_cluster_0.COUNT;
      END IF;
    END LOOP;

    IF (isInitialLoad = 'Y') THEN
      mdm_alterTtIndices(parm_entity_type,'REBUILD');
    END IF;
    
    err_location := 200;
    IF (lower(parm_process_type) = lower('BULK')) THEN
        -- Delete staging tables
        strSQL := 'DROP TABLE '||entityStgTbl;
        EXECUTE IMMEDIATE strSQL;

        strSQL := 'DROP TABLE '||entityCcTbl;
        EXECUTE IMMEDIATE strSQL;

        strSQL := 'DROP TABLE '||stgTbl;
        EXECUTE IMMEDIATE strSQL;

        strSQL := 'DROP TABLE '||clusterStgTbl;
        EXECUTE IMMEDIATE strSQL;
    ELSE
      mdm_deleteProcessedRecords(parm_entity_type,parm_staging_id,startCluster,endCluster,'MRM',increment);
    END IF;

    --mdm_log_error('MDM_STAGING_GOLIVE',null,0,'mdm_entity_id','mdm_entity_goLive',SQLCODE,'Cleared staging tables :'||parm_staging_id,systimestamp);

    mdm_end_process_control(ret_process_id,'Y');

    --mdm_log_error('MDM_STAGING_GOLIVE',null,0,'mdm_entity_id','mdm_entity_goLive',SQLCODE,'Finished :'||parm_staging_id,systimestamp);

    open returnCursor for select 'Y' as process_complete from dual;
  EXCEPTION
    WHEN OTHERS THEN
      err_message := 'location : '||err_location||' : '||SQLERRM;
      mdm_log_error('MDM_STAGING_GOLIVE',null,0,'mdm_entity_id','mdm_entity_goLive',SQLCODE,err_message,systimestamp);
      ROLLBACK;
      -- Delete from entity staging tables
      mdm_deleteProcessedRecords(parm_entity_type,parm_staging_id,startCluster,endCluster,parm_process_type,increment);

      mdm_end_process_control(ret_process_id,'N');

      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_entity_golive(firstClusterId	in INTEGER,
							lastClusterId		in INTEGER,
							parm_staging_id		in INTEGER,
							tt_columns			in VARCHAR2,
							parm_entity_type	in VARCHAR2,
							parm_current_dttm	in TIMESTAMP,
							parm_userid			in VARCHAR2,
              parm_process_type IN VARCHAR2,
              parm_match_type   IN INTEGER,
              parm_comment IN nvarchar2)
  AS

    stgTbl		VARCHAR2(30);
    entityTtTbl  VARCHAR2(30);
    entityStTbl  VARCHAR2(30);
    clusterStgTbl VARCHAR2(30);
    strSQL				VARCHAR2(32000);
    strOldSurvivorSql	VARCHAR2(4000);
    err_location		INTEGER;
    err_message	    VARCHAR2(200);
    history_comment NVARCHAR2(200);
    history_reason  VARCHAR2(1);
    mtClause        VARCHAR2(30);
    mt0   BOOLEAN := false;
    mt1   BOOLEAN := false;
    mt2   BOOLEAN := false;
    mt3   BOOLEAN := false;
    mt4   BOOLEAN := false;
    TYPE sibling_hier_rec IS RECORD
    (
		old_tree_id	INTEGER,
		new_tree_id	INTEGER
	  );
    TYPE sibling_hier IS TABLE OF sibling_hier_rec;
    sibling_hier_tbl	sibling_hier;
    TYPE match_type_rec IS RECORD
    (
      match_type  INTEGER
    );
    TYPE match_type_tbl IS TABLE OF match_type_rec;
    mt_tbl    match_type_tbl;
  BEGIN
    entityTtTbl := 'MDM_' || parm_entity_type || '_TT';
    IF (lower(parm_process_type) = lower('BULK')) THEN
      stgTbl := 'MDM_STAGING_'||parm_staging_id;
      entityStTbl := 'MDM_BULK_ST_'||parm_staging_id;
      clusterStgTbl := 'MDM_BULK_CS_'||parm_staging_id;
    ELSE
      stgTbl := 'MDM_STAGING';
      entityStTbl := 'MDM_' || parm_entity_type || '_ST';
    END IF;

    err_location := 51;
    IF (parm_match_type = 0) THEN
      mt0 := true;
    ELSE
      strSQL := 'SELECT DISTINCT match_type FROM '||entityStTbl||'
                WHERE mdm_staging_id = :1
                  AND mdm_entity_cluster_id >= :2
                  AND mdm_entity_cluster_id <= :3';
      EXECUTE IMMEDIATE strSQL BULK COLLECT INTO mt_tbl USING parm_staging_id,firstClusterId,lastClusterId;

      FOR k in 1..mt_tbl.COUNT LOOP
        if (mt_tbl(k).match_type = 1) then
          mt1 := true;
        end if;
        if (mt_tbl(k).match_type = 2) then
          mt2 := true;
        end if;
        if (mt_tbl(k).match_type = 3) then
          mt3 := true;
        end if;
        if (mt_tbl(k).match_type = 4) then
          mt4 := true;
        end if;
      END LOOP;
    END IF;

    --mdm_log_error('MDM_ENTITY_GOLIVE',null,0,'mdm_entity_id','mdm_entity_goLive',SQLCODE,'Start iteration for cluster ids from : '||firstClusterId||' to '||lastClusterId,systimestamp);

    /**************************************************************************************************************************************************************************
		 Update collapse clusters in transpose table
		**************************************************************************************************************************************************************************/
    err_location := 60;

    strSQL := 'UPDATE '||entityTtTbl||'
                  SET mdm_entity_cluster_id = (SELECT DISTINCT st.mdm_entity_cluster_id
                           FROM '||stgTbl||' st
                          WHERE st.mdm_staging_id = :1
                            AND st.match_type = 2
                            AND st.old_cluster_id <> st.mdm_entity_cluster_id
                            AND st.mdm_entity_cluster_id >= :2
                            AND st.mdm_entity_cluster_id <= :3
                            AND '||entityTtTbl||'.mdm_entity_cluster_id = st.old_cluster_id)
                 WHERE EXISTS (SELECT 1
                           FROM '||stgTbl||' st
                          WHERE st.mdm_staging_id = :4
                            AND st.match_type = 2
                            AND st.old_cluster_id <> st.mdm_entity_cluster_id
                            AND st.mdm_entity_cluster_id >= :5
                            AND st.mdm_entity_cluster_id <= :6
                            AND '||entityTtTbl||'.mdm_entity_cluster_id = st.old_cluster_id)
                 AND mdm_survivor = ''N''
                 AND (mdm_valid_to_dttm > systimestamp OR mdm_valid_to_dttm IS NULL)';

    IF (mt2) THEN
       EXECUTE IMMEDIATE strSQL USING parm_staging_id,firstClusterId,lastClusterId,parm_staging_id,firstClusterId,lastClusterId;
    END IF;
    --mdm_log_error('MDM_ENTITY_GOLIVE',null,0,'mdm_entity_id','mdm_entity_goLive',SQLCODE,'Update collapse clusters',systimestamp);

    /**************************************************************************************************************************************************************************
		 Update move records in transpose table
		**************************************************************************************************************************************************************************/
    err_location := 70;

    strSql := 'UPDATE '||entityTtTbl||'
					        SET mdm_entity_cluster_id = (SELECT distinct st.mdm_entity_cluster_id
													     FROM '||stgTbl||' st
													    WHERE st.mdm_staging_id = :1
														    AND st.match_type > 2
														    AND st.old_cluster_id <> st.mdm_entity_cluster_id
														    AND st.mdm_entity_cluster_id >= :2
														    AND st.mdm_entity_cluster_id <= :3
														    AND '||entityTtTbl||'.mdm_entity_id = st.mdm_entity_id)
						     WHERE EXISTS (SELECT 1
										           FROM '||stgTbl||' st
										          WHERE st.mdm_staging_id = :4
											          AND st.match_type > 2
											          AND st.old_cluster_id <> st.mdm_entity_cluster_id
											          AND st.mdm_entity_cluster_id >= :5
											          AND st.mdm_entity_cluster_id <= :6
											          AND '||entityTtTbl||'.mdm_entity_id = st.mdm_entity_id)';

    IF (mt3 OR mt4) THEN
      EXECUTE IMMEDIATE strSql USING parm_staging_id,firstClusterId,lastClusterId,parm_staging_id,firstClusterId,lastClusterId;
    END IF;
    --mdm_log_error('MDM_ENTITY_GOLIVE',null,0,'mdm_entity_id','mdm_entity_goLive',SQLCODE,'Update move records',systimestamp);

    /**************************************************************************************************************************************************************************
		 Retire old contributors and survivors from audit log
		**************************************************************************************************************************************************************************/
    -- Retire previous contributors: Note that if an update includes multiple records from the
		-- same source system, they'll still appear in the cluster (but will be retired on the
		-- next update that references the same ssid/ssrid)

		strOldSurvivorSQL := 'SELECT tt.mdm_entity_id
			FROM '||entityTtTbl||' tt, '||entityStTbl||' st
			WHERE st.mdm_staging_id = :1
				AND st.mdm_entity_cluster_id >= :2
				AND st.mdm_entity_cluster_id <= :3
				AND st.mdm_survivor = ''N''
				AND st.match_type > 0
				AND tt.mdm_src_sys_id = st.mdm_src_sys_id
				AND tt.mdm_src_sys_rec_id = st.mdm_src_sys_rec_id
                AND tt.mdm_valid_to_dttm IS NULL
			UNION
			SELECT tt.mdm_entity_id
				FROM '||entityTtTbl||' tt
				WHERE tt.mdm_entity_cluster_id IN (
					SELECT mdm_entity_cluster_id
					  FROM '||entityStTbl||'
					 WHERE mdm_staging_id = :4
             AND match_type > 0
						 AND mdm_entity_cluster_id >= :5
						 AND mdm_entity_cluster_id <= :6
          UNION
          SELECT old_cluster_id
					  FROM '||stgTbl||'
					 WHERE mdm_staging_id = :7
						 AND mdm_entity_cluster_id >= :8
						 AND mdm_entity_cluster_id <= :9
						 AND match_type > 1
						 AND old_cluster_id <> mdm_entity_cluster_id
					)
				AND tt.mdm_survivor = ''Y''
				AND (tt.mdm_valid_to_dttm IS NULL OR tt.mdm_valid_to_dttm > systimestamp)';

    err_location := 80;

    strSQL:= 'INSERT INTO mdm_'||parm_entity_type||'_al (TABLE_NAME,RECORD_ID,USER_ACTION,MDM_MODIFIED_BY,MODIFIED_DTTM)
               SELECT ''MDM_'||parm_entity_type||'_TT'',contr.mdm_entity_id,''RETIRE'','''||parm_userid||''',systimestamp
                 FROM ('||strOldSurvivorSQL||') contr';

    IF (mt1 OR mt2 OR mt3 OR mt4) THEN
       EXECUTE IMMEDIATE strSQL USING parm_staging_id,firstClusterId,lastClusterId,parm_staging_id,firstClusterId,lastClusterId,parm_staging_id,firstClusterId,lastClusterId;
    END IF;
    --mdm_log_error('MDM_ENTITY_GOLIVE',null,0,'mdm_entity_id','mdm_entity_goLive',SQLCODE,'Retire old contributors and survivors from audit log',systimestamp);

    /**************************************************************************************************************************************************************************
		 Retire old contributors and survivors from transpose table
		**************************************************************************************************************************************************************************/
    err_location := 90;

    strSQL := 'UPDATE '||entityTtTbl||'
                  SET mdm_valid_to_dttm = systimestamp
                WHERE mdm_entity_id IN ('||strOldSurvivorSQL||')';

    IF (mt1 OR mt2 OR mt3 OR mt4) THEN
       EXECUTE IMMEDIATE strSQL USING parm_staging_id,firstClusterId,lastClusterId,parm_staging_id,firstClusterId,lastClusterId,parm_staging_id,firstClusterId,lastClusterId;
    END IF;
    --mdm_log_error('MDM_ENTITY_GOLIVE',null,0,'mdm_entity_id','mdm_entity_goLive',SQLCODE,'Retire old contributors and survivors from transpose table',systimestamp);

    /**************************************************************************************************************************************************************************
		 Insert new records into transpose table
		**************************************************************************************************************************************************************************/
    err_location := 100;

    IF (mt0) AND (lower(parm_process_type) = lower('BULK')) THEN
      strSql := 'INSERT INTO '||entityTtTbl||' (mdm_staging_id,mdm_entity_id,mdm_src_sys_id,mdm_src_sys_rec_id,mdm_language_id,mdm_entity_cluster_id,mdm_survivor,mdm_valid_from_dttm'||tt_columns||')
					SELECT est.mdm_staging_id,mdm_entity_seq.nextval,est.mdm_src_sys_id,
                 CASE WHEN est.mdm_src_sys_rec_id IS NULL THEN TO_NCHAR(mdm_entity_seq.currval) ELSE est.mdm_src_sys_rec_id END,
                 est.mdm_language_id,cst.mdm_entity_cluster_id,est.mdm_survivor,:1'||tt_columns||'
					FROM '||entityStTbl||' est, '||clusterStgTbl||' cst
					WHERE cst.mdm_entity_cluster_id >= :2
						AND cst.mdm_entity_cluster_id <= :3
            AND est.cid = cst.cid';
      EXECUTE IMMEDIATE strSQL USING parm_current_dttm,firstClusterId,lastClusterId;
    ELSE
      IF (mt0) THEN
        mtClause := ' AND est.match_type = 0';
      ELSE
        mtClause := ' AND est.match_type > 0';
      END IF;
      strSql := 'INSERT INTO '||entityTtTbl||' (mdm_staging_id,mdm_entity_id,mdm_src_sys_id,mdm_src_sys_rec_id,mdm_language_id,mdm_entity_cluster_id,mdm_survivor,mdm_valid_from_dttm'||tt_columns||')
					SELECT est.mdm_staging_id,mdm_entity_seq.nextval,est.mdm_src_sys_id,
                 CASE WHEN est.mdm_src_sys_rec_id IS NULL THEN TO_NCHAR(mdm_entity_seq.currval) ELSE est.mdm_src_sys_rec_id END,
                 est.mdm_language_id,est.mdm_entity_cluster_id,est.mdm_survivor,:1'||tt_columns||'
					FROM '||entityStTbl||' est
					WHERE est.mdm_staging_id = :2
						AND est.mdm_entity_cluster_id >= :3
						AND est.mdm_entity_cluster_id <= :4'||mtClause;
      EXECUTE IMMEDIATE strSQL USING parm_current_dttm,parm_staging_id,firstClusterId,lastClusterId;
    END IF;

    --mdm_log_error('MDM_ENTITY_GOLIVE',null,0,'mdm_entity_id','mdm_entity_goLive',SQLCODE,'Insert new records into transpose table',systimestamp);

    /**************************************************************************************************************************************************************************
		 Rename / Insert clusters in entity clusters table
		**************************************************************************************************************************************************************************/
    err_location := 120;

    IF (mt0) AND (lower(parm_process_type) = lower('BULK')) THEN
      strSQL := 'INSERT INTO mdm_entity_clusters
                SELECT cst.mdm_entity_cluster_id,est.mdm_entity_cluster_name, ''N''
                  FROM '||entityStTbl||' est, '||clusterStgTbl||' cst
                 WHERE cst.mdm_entity_cluster_id >= :1
                   AND cst.mdm_entity_cluster_id <= :2
                   AND cst.cid = est.cid
	                 AND est.mdm_survivor = ''Y''';
      EXECUTE IMMEDIATE strSQL USING firstClusterId,lastClusterId;
    ELSE
      strSQL := 'INSERT INTO mdm_entity_clusters
                SELECT mdm_entity_cluster_id,mdm_entity_cluster_name, ''N''
                  FROM '||entityStTbl||'
                 WHERE mdm_staging_id = :1
                   AND mdm_entity_cluster_id >= :2
                   AND mdm_entity_cluster_id <= :3
	                 AND mdm_survivor = ''Y''
                   AND (match_type = 0 OR match_type = 4)';
       IF (mt0 OR mt4) THEN
          EXECUTE IMMEDIATE strSQL USING parm_staging_id,firstClusterId,lastClusterId;
       END IF;
    END IF;

    strSQL := 'MERGE INTO mdm_entity_clusters ec
		            USING (SELECT mdm_entity_cluster_id, mdm_entity_cluster_name, match_type
				                 FROM '||entityStTbl||'
				                WHERE mdm_staging_id = :1
					                AND mdm_entity_cluster_id >= :2
					                AND mdm_entity_cluster_id <= :3
					                AND mdm_survivor = ''Y''
                          AND match_type > 0 AND match_type < 4) s
			             ON (ec.mdm_entity_cluster_id = s.mdm_entity_cluster_id)
		           WHEN MATCHED THEN
			           UPDATE
				           SET ec.mdm_entity_cluster_name = s.mdm_entity_cluster_name
			           WHERE ec.mdm_entity_cluster_name <> s.mdm_entity_cluster_name';
    IF (mt1 OR mt2 OR mt3) THEN
      EXECUTE IMMEDIATE strSQL USING parm_staging_id,firstClusterId,lastClusterId;
    END IF;

    --mdm_log_error('MDM_ENTITY_GOLIVE',null,0,'mdm_entity_id','mdm_entity_goLive',SQLCODE,'Rename / Insert clusters',systimestamp);

    /**************************************************************************************************************************************************************************
		 Insert collapse clusters into cluster mapping
		**************************************************************************************************************************************************************************/
    err_location := 130;
    IF (mt2) THEN
      strSQL:= 'INSERT INTO mdm_cluster_mapping
      SELECT DISTINCT old_cluster_id,mdm_entity_cluster_id
        FROM '||stgTbl||'
       WHERE mdm_staging_id = :1
         AND mdm_entity_cluster_id >= :2
         AND mdm_entity_cluster_id <= :3
         AND match_type = 2
         AND old_cluster_id <> mdm_entity_cluster_id';
       EXECUTE IMMEDIATE strSQL USING parm_staging_id, firstClusterId, lastClusterId;
    END IF;
    --mdm_log_error('MDM_ENTITY_GOLIVE',null,0,'mdm_entity_id','mdm_entity_goLive',SQLCODE,'Insert into cluster mapping',systimestamp);

    /**************************************************************************************************************************************************************************
		 Update / Insert cluster member history
		**************************************************************************************************************************************************************************/
    err_location := 140;
    IF (mt2 OR mt3 OR mt4) THEN
      IF parm_comment IS NULL  THEN
        IF mt2 THEN
           history_comment := 'Cluster Collapse';
           history_reason := 'C';
        ELSE
           history_comment := 'Move Record';
           history_reason := 'M';
        END IF;
      ELSE
        history_comment := parm_comment;
        IF mt2 THEN
          history_reason := 'C';
        ELSE
          history_reason := 'M';
        END IF;
      END IF;

      -- Retire any previous cluster member history records for match type 2 records
      strSQL := 'UPDATE mdm_cluster_member_history
        SET mdm_valid_to_dttm = :1
      WHERE mdm_entity_id IN (SELECT st.mdm_entity_id
                        FROM '||stgTbl||' st
                        WHERE st.mdm_staging_id = :2
                          AND st.mdm_entity_cluster_id >= :3
                          AND st.mdm_entity_cluster_id <= :4
                          AND st.match_type > 1
                          AND st.old_cluster_id <> st.mdm_entity_cluster_id)
            AND (mdm_valid_to_dttm > :5 OR mdm_valid_to_dttm IS NULL)';
      EXECUTE IMMEDIATE strSQL USING parm_current_dttm, parm_staging_id, firstClusterId, lastClusterId, parm_current_dttm;

      -- Insert new cluster member history records
      strSQL := 'INSERT INTO mdm_cluster_member_history (mdm_entity_cluster_id,mdm_entity_id,mdm_comment,mdm_reason,mdm_modified_dttm)
                     SELECT old_cluster_id,mdm_entity_id,:1,:2,:3
                       FROM '||stgTbl||'
                      WHERE mdm_staging_id = :4
                      AND mdm_entity_cluster_id >= :5
                      AND mdm_entity_cluster_id <= :6
                      AND match_type > 1
                      AND old_cluster_id <> mdm_entity_cluster_id';
      EXECUTE IMMEDIATE strSQL USING history_comment, history_reason, parm_current_dttm, parm_staging_id, firstClusterId, lastClusterId;
    END IF;
    --mdm_log_error('MDM_ENTITY_GOLIVE',null,0,'mdm_entity_id','mdm_entity_goLive',SQLCODE,'Update / Insert cluster member history',systimestamp);

    /**************************************************************************************************************************************************************************
		 Remove retired clusters from forced clusters
		**************************************************************************************************************************************************************************/
    err_location := 170;
    IF (mt2) THEN
      strSQL := 'UPDATE mdm_forced_clusters
        SET original_cluster_id = (SELECT distinct -1
                      FROM '||stgTbl||'
                      WHERE mdm_staging_id = :1
                        AND mdm_entity_cluster_id >= :2
                        AND mdm_entity_cluster_id <= :3
                        AND match_type = 2
                        AND old_cluster_id <> mdm_entity_cluster_id
                        AND old_cluster_id = mdm_forced_clusters.original_cluster_id)
      WHERE EXISTS (SELECT 1
              FROM '||stgTbl||'
              WHERE mdm_staging_id = :4
                AND mdm_entity_cluster_id >= :5
                AND mdm_entity_cluster_id <= :6
                AND match_type = 2
                AND old_cluster_id <> mdm_entity_cluster_id
                AND (old_cluster_id = mdm_forced_clusters.original_cluster_id))';
      EXECUTE IMMEDIATE strSQL USING parm_staging_id, firstClusterId, lastClusterId, parm_staging_id, firstClusterId, lastClusterId;

      strSQL := 'UPDATE mdm_forced_clusters
          SET current_cluster_id = (SELECT distinct -1
                        FROM '||stgTbl||'
                        WHERE mdm_staging_id = :1
                          AND mdm_entity_cluster_id >= :2
                          AND mdm_entity_cluster_id <= :3
                          AND match_type = 2
                          AND old_cluster_id <> mdm_entity_cluster_id
                          AND old_cluster_id = mdm_forced_clusters.current_cluster_id)
      WHERE EXISTS (SELECT 1
              FROM '||stgTbl||'
              WHERE mdm_staging_id = :4
                AND mdm_entity_cluster_id >= :5
                AND mdm_entity_cluster_id <= :6
                AND match_type = 2
                AND old_cluster_id <> mdm_entity_cluster_id
                AND (old_cluster_id = mdm_forced_clusters.current_cluster_id))';
      EXECUTE IMMEDIATE strSQL USING parm_staging_id, firstClusterId, lastClusterId, parm_staging_id, firstClusterId, lastClusterId;
    END IF;
    --mdm_log_error('MDM_ENTITY_GOLIVE',null,0,'mdm_entity_id','mdm_entity_goLive',SQLCODE,'Remove retired clusters from forced clusters',systimestamp);

    /**************************************************************************************************************************************************************************
		 Remove retired clusters from relationships
		**************************************************************************************************************************************************************************/
    err_location := 180;
    IF (mt2 OR mt4) THEN
      strSQL := 'UPDATE mdm_entity_rel
             SET mdm_valid_to_dttm = systimestamp
           WHERE mdm_from_cluster_id IN (SELECT old_cluster_id
                       FROM '||stgTbl||'
                      WHERE mdm_staging_id = :1
                        AND mdm_entity_cluster_id >= :2
                        AND mdm_entity_cluster_id <= :3
                        AND (match_type = 2 OR match_type = 4)
                        AND old_cluster_id <> mdm_entity_cluster_id)
              OR mdm_to_cluster_id IN (SELECT old_cluster_id
                       FROM '||stgTbl||'
                      WHERE mdm_staging_id = :4
                        AND mdm_entity_cluster_id >= :5
                        AND mdm_entity_cluster_id <= :6
                        AND (match_type = 2 OR match_type = 4)
                        AND old_cluster_id <> mdm_entity_cluster_id)';
      EXECUTE IMMEDIATE strSQL USING parm_staging_id, firstClusterId, lastClusterId, parm_staging_id, firstClusterId, lastClusterId;
    END IF;
    --mdm_log_error('MDM_ENTITY_GOLIVE',null,0,'mdm_entity_id','mdm_entity_goLive',SQLCODE,'Remove retired clusters from relationships',systimestamp);

		/**************************************************************************************************************************************************************************
		 Commit processed rows
		**************************************************************************************************************************************************************************/
		err_location := 190;

    COMMIT;

    --mdm_log_error('MDM_ENTITY_GOLIVE',null,0,'mdm_entity_id','mdm_entity_goLive',SQLCODE,'Iteration commited for cluster ids from : '||firstClusterId||' to '||lastClusterId,systimestamp);

  EXCEPTION
    WHEN OTHERS THEN
      ROLLBACK;
      err_message := 'location : '||err_location||' : '||SQLERRM;
      mdm_log_error('MDM_ENTITY_GOLIVE',null,0,'mdm_entity_id','mdm_entity_goLive',SQLCODE,err_message,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_encrypt_value (parm_value           IN VARCHAR2,
                               returnCursor  IN OUT refCursor) AS

  enc_value raw(4000);
  input_raw raw(2000);

  BEGIN
    input_raw := utl_raw.cast_to_raw(parm_value);

    enc_value := dbms_crypto.encrypt(input_raw,getEncryptionType,getEncryptionKey);

    OPEN returnCursor FOR
      SELECT enc_value FROM dual;
  EXCEPTION
  WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error(null,null,0,null,'mdm_encrypt_value',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_getDecryptTtCols (parm_entity_type_id IN INTEGER,
                                  returnCursor  IN OUT refCursor) AS
  tt_columns varchar2(4000);
  attr_name varchar2(50);
  encrypt_flag char(1);
  parent_id integer;
  CURSOR get_attrs IS
      SELECT mdm_attr_name, mdm_encrypt_flag,mdm_parent_attr_id FROM mdm_attrs
       WHERE mdm_entity_type_id IN (SELECT mdm_entity_type_id FROM mdm_entity_types
                                     WHERE (mdm_valid_to_dttm > systimestamp or mdm_valid_to_dttm is null)
                                    START WITH mdm_entity_type_id = parm_entity_type_id
                                    CONNECT BY PRIOR mdm_parent_id = mdm_entity_type_id)
         AND mdm_valid_from_dttm < systimestamp AND (mdm_valid_to_dttm is null or mdm_valid_to_dttm > systimestamp)
         AND mdm_attr_id > 0;
  BEGIN
    tt_columns:='';

    OPEN get_attrs;
    LOOP
      fetch get_attrs into attr_name,encrypt_flag,parent_id;
      EXIT WHEN get_attrs%NOTFOUND;
      IF (encrypt_flag = 'Y' AND parent_id IS NULL) THEN
         tt_columns:=tt_columns||',utl_raw.cast_to_varchar2(dbms_crypto.decrypt('||attr_name||',md.getEncryptionType,md.getEncryptionKey)) as '||attr_name;
      ELSE
         tt_columns:=tt_columns||','||attr_name;
      END IF;
    END LOOP;
    CLOSE get_attrs;

    OPEN returnCursor FOR SELECT tt_columns FROM dual;
  EXCEPTION
  WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error(null,null,0,null,'mdm_getDecryptTtCols',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_decryptCols (parm_entity_type     IN VARCHAR2,
                             parm_entity_type_id  IN INTEGER,
                             parm_tbl_suffix      IN VARCHAR2,
                             returnCursor  IN OUT refCursor) AS
  sqlStmt varchar2(10000);
  tt_columns varchar2(4000);
  TYPE tt_cursor IS REF CURSOR;
  tt_curs tt_cursor;

  BEGIN
    mdm_getDecryptTtCols(parm_entity_type_id,tt_curs);

    FETCH tt_curs INTO tt_columns;

    sqlStmt:= 'select mdm_entity_id,mdm_src_sys_id,mdm_src_sys_rec_id,mdm_language_id,'||
                      'mdm_valid_from_dttm,mdm_valid_to_dttm,mdm_entity_cluster_id,mdm_survivor'||tt_columns||' '||
                 'from mdm_'||parm_entity_type||'_'||parm_tbl_suffix;

    OPEN returnCursor FOR sqlStmt;
  EXCEPTION
  WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error(null,null,0,null,'mdm_decryptCols',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_decryptCols_byClusterId (parm_entity_type IN VARCHAR2,
                                         parm_cluster_id  IN INTEGER,
                                         parm_tt_columns  IN VARCHAR2,
                                         parm_tbl_suffix  IN VARCHAR2,
                                         returnCursor   IN OUT refCursor) AS
  sqlStmt varchar2(10000);
  entityTypeId  integer;

  BEGIN

    select mdm_entity_type_id into entityTypeId from mdm_entity_types
     where lower(mdm_entity_type) = lower(parm_entity_type)
       and mdm_valid_from_dttm <= systimestamp
       and (mdm_valid_to_dttm is null or mdm_valid_to_dttm > systimestamp);

    sqlStmt:='select fc.original_cluster_id,fc.current_cluster_id,ev.mdm_entity_type_id,ev.mdm_entity_id,ev.mdm_src_sys_id,ev.mdm_src_sys_rec_id,ev.mdm_language_id,'||
                    'ev.mdm_valid_from_dttm,ev.mdm_valid_to_dttm,ev.mdm_entity_cluster_id,ev.mdm_survivor'||parm_tt_columns||' '||
               'from mdm_'||parm_entity_type||'_'||parm_tbl_suffix||' ev '||
              'left join mdm_forced_clusters fc on fc.src_sys_id = ev.mdm_src_sys_id and fc.src_sys_rec_id = ev.mdm_src_sys_rec_id and fc.entity_type_id = :1 '||
                'where ev.mdm_entity_cluster_id = :2 '||
              'order by ev.mdm_survivor desc';

    OPEN returnCursor FOR sqlStmt USING entityTypeId,parm_cluster_id;

  EXCEPTION
  WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error(null,null,0,null,'mdm_decryptCv_byClusterId',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_decryptCols_byEntityId (parm_entity_type IN VARCHAR2,
                                        parm_entity_id  IN INTEGER,
                                        parm_tt_columns  IN VARCHAR2,
                                        parm_tbl_suffix  IN VARCHAR2,
                                        returnCursor   IN OUT refCursor) AS
  sqlStmt varchar2(10000);

  BEGIN

    sqlStmt:= 'select mdm_entity_id,mdm_src_sys_id,mdm_src_sys_rec_id,mdm_language_id,'||
                      'mdm_valid_from_dttm,mdm_valid_to_dttm,mdm_entity_cluster_id,mdm_survivor'||parm_tt_columns||' '||
                 'from mdm_'||parm_entity_type||'_'||parm_tbl_suffix||' '||
                'where mdm_entity_id = :1';

    OPEN returnCursor FOR sqlStmt USING parm_entity_id;

  EXCEPTION
  WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error('mdm_'||parm_entity_type||parm_tbl_suffix,null,0,null,'mdm_decryptCols_byEntityId',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_getDecryptString (parm_attr_name IN VARCHAR2,
                                  returnCursor IN OUT refCursor) AS
  BEGIN

    OPEN returnCursor FOR
       SELECT 'utl_raw.cast_to_varchar2(dbms_crypto.decrypt('||parm_attr_name||',md.getEncryptionType,md.getEncryptionKey))' AS attr_string FROM dual;

  EXCEPTION
  WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error(null,null,0,null,'mdm_getDecryptString',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_queryCluster (parm_entity_type     IN VARCHAR2,
                              parm_cluster_id      IN INTEGER,
                              parm_show_retired    IN VARCHAR2,
                              returnCursor  IN OUT refCursor) AS
  sqlStmt varchar2(10000);
  tt_columns varchar2(4000);
  entityTypeId integer;
  TYPE tt_cursor IS REF CURSOR;
  tt_curs tt_cursor;

  BEGIN
    SELECT mdm_entity_type_id INTO entityTypeId FROM mdm_entity_types WHERE lower(mdm_entity_type) = lower(parm_entity_type);
    mdm_getDecryptTtCols(entityTypeId,tt_curs);

    FETCH tt_curs INTO tt_columns;

    IF (parm_show_retired = 'Y') THEN
        sqlStmt:= 'select * from (select '||entityTypeId||' as mdm_entity_type_id,v.mdm_entity_id,v.mdm_src_sys_id,v.mdm_src_sys_rec_id,v.mdm_language_id,'||
                         'v.mdm_valid_from_dttm,v.mdm_valid_to_dttm,v.mdm_entity_cluster_id,v.mdm_survivor'||tt_columns||','||
                         'null as mod_dttm,h.mdm_comment, h.mdm_reason from mdm_'||parm_entity_type||'_tt v '||
                    'left join mdm_cluster_member_history h on v.mdm_entity_id=h.mdm_entity_id '||
                    'where v.mdm_entity_cluster_id=:1 and (h.mdm_valid_to_dttm > systimestamp or h.mdm_valid_to_dttm is null) '||
                  'union '||
                  'select '||entityTypeId||' as mdm_entity_type_id,v.mdm_entity_id,v.mdm_src_sys_id,v.mdm_src_sys_rec_id,v.mdm_language_id,'||
                         'v.mdm_valid_from_dttm,v.mdm_valid_to_dttm,v.mdm_entity_cluster_id,v.mdm_survivor'||tt_columns||','||
                         'h.mdm_modified_dttm as mod_dttm,h.mdm_comment,h.mdm_reason '||
                         'from mdm_'||parm_entity_type||'_tt v, mdm_cluster_member_history h '||
                   'where h.mdm_entity_cluster_id=:2 and h.mdm_entity_id=v.mdm_entity_id ) e '||
                 'order by mdm_valid_from_dttm desc,mdm_src_sys_id asc';

       OPEN returnCursor FOR sqlStmt
         USING parm_cluster_id,parm_cluster_id;
    ELSIF (parm_show_retired = 'N') THEN
        sqlStmt := 'select '||entityTypeId||' as mdm_entity_type_id,v.mdm_entity_id,v.mdm_src_sys_id,v.mdm_src_sys_rec_id,v.mdm_language_id,'||
                          'v.mdm_valid_from_dttm,v.mdm_valid_to_dttm,v.mdm_entity_cluster_id,v.mdm_survivor'||tt_columns||','||
                          'h.mdm_comment,h.mdm_reason,h.mdm_modified_dttm as mod_dttm from mdm_'||parm_entity_type||'_tt v '||
                    'left join mdm_cluster_member_history h on v.mdm_entity_id=h.mdm_entity_id '||
                   'where v.mdm_entity_cluster_id = :1 '||
                     'and v.mdm_valid_from_dttm <= systimestamp '||
                     'and (v.mdm_valid_to_dttm is null or v.mdm_valid_to_dttm > systimestamp) '||
                  'order by v.mdm_valid_from_dttm desc,v.mdm_src_sys_id asc';
       OPEN returnCursor FOR sqlStmt
         USING parm_cluster_id;
    END IF;

  EXCEPTION
  WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error(null,null,0,parm_cluster_id,'mdm_queryCluster',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_getAttrs (parm_entity_type     IN VARCHAR2,
                          parm_attr_type       IN CHAR,
                          returnCursor  IN OUT refCursor) AS

  sqlStmt  VARCHAR2(500);
  typeClause  VARCHAR2(200);

  BEGIN

    IF (parm_attr_type = 'U') THEN
       typeClause := ' and mdm_parent_attr_id is null ';
    ELSE IF (parm_attr_type = 'D') THEN
            typeClause := ' ';
         ELSE IF (parm_attr_type = 'R') THEN
                 typeClause := 'and mdm_parent_attr_id is null and (mdm_required=''Y'' or (mdm_attr_id IN (select mdm_entity_type_id '||
                                               'from mdm_entity_types '||
                                              'where (mdm_valid_to_dttm > systimestamp or mdm_valid_to_dttm is null) '||
                                              'start with lower(mdm_entity_type) = lower(:1) '||
                                              'connect by prior mdm_parent_id = mdm_entity_type_id) '||'))';
              ELSE IF (parm_attr_type = 'E') THEN
                      typeClause := 'and mdm_parent_attr_id is null and mdm_encrypt_flag = ''Y'' ';
                   ELSE
                      typeClause := ' ';
                   END IF;
              END IF;
         END IF;
    END IF;

    sqlStmt := 'select mdm_attr_id, mdm_attr_name from mdm_attrs '||
                'where mdm_entity_type_id in (select mdm_entity_type_id '||
                                               'from mdm_entity_types '||
                                              'where (mdm_valid_to_dttm > systimestamp or mdm_valid_to_dttm is null) '||
                                              'start with lower(mdm_entity_type) = lower(:1) '||
                                              'connect by prior mdm_parent_id = mdm_entity_type_id) '||
                  'and (mdm_valid_to_dttm > systimestamp or mdm_valid_to_dttm is null) '||typeClause||' '||
                  'order by mdm_attr_id';

    OPEN returnCursor FOR sqlStmt USING parm_entity_type;

  EXCEPTION
  WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error(null,null,0,null,'mdm_getAttrs',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_retireEntityType (parm_entity_type_id  IN INTEGER, returnCursor  IN OUT refCursor) AS
    retire_dttm  date;
    hierCount integer;

  BEGIN
    select sysdate into retire_dttm from dual;

    -- Retire attributes
    update mdm_attrs set mdm_valid_to_dttm = retire_dttm
    where mdm_entity_type_id in (
      select mdm_entity_type_id
      from mdm_entity_types
      where (mdm_valid_to_dttm is null or mdm_valid_to_dttm > sysdate)
      start with mdm_entity_type_id=parm_entity_type_id connect by prior mdm_entity_type_id=mdm_parent_id);

    update mdm_attr_access set mdm_active = 'N'
    where mdm_entity_type_id in (
      select mdm_entity_type_id
      from mdm_entity_types
      where (mdm_valid_to_dttm is null or mdm_valid_to_dttm > sysdate)
      start with mdm_entity_type_id=parm_entity_type_id connect by prior mdm_entity_type_id=mdm_parent_id);

        -- Cluster Conditions
    update mdm_cluster_conditions set mdm_valid_to_dttm = retire_dttm
    where mdm_entity_type_id in (
      select mdm_entity_type_id
      from mdm_entity_types
      where (mdm_valid_to_dttm is null or mdm_valid_to_dttm > sysdate)
      start with mdm_entity_type_id=parm_entity_type_id connect by prior mdm_entity_type_id=mdm_parent_id);

    -- relationship type
    update mdm_entity_rel_types set mdm_valid_to_dttm = retire_dttm
    where mdm_from_entity_type_id in (
      select mdm_entity_type_id
      from mdm_entity_types
      where (mdm_valid_to_dttm is null or mdm_valid_to_dttm > sysdate)
      start with mdm_entity_type_id=parm_entity_type_id connect by prior mdm_entity_type_id=mdm_parent_id)
      or 
      mdm_to_entity_type_id in (
      select mdm_entity_type_id
      from mdm_entity_types
      where (mdm_valid_to_dttm is null or mdm_valid_to_dttm > sysdate)
      start with mdm_entity_type_id=parm_entity_type_id connect by prior mdm_entity_type_id=mdm_parent_id);

    -- Retire entity type roles
    update mdm_entity_type_access set mdm_active = 'N'
    where mdm_entity_type_id in (
      select mdm_entity_type_id
      from mdm_entity_types
      where (mdm_valid_to_dttm is null or mdm_valid_to_dttm > sysdate)
      start with mdm_entity_type_id=parm_entity_type_id connect by prior mdm_entity_type_id=mdm_parent_id);

    -- Finally retire entity type
    update mdm_entity_types set mdm_valid_to_dttm = retire_dttm
    where mdm_entity_type_id in (
      select mdm_entity_type_id
      from mdm_entity_types
      where (mdm_valid_to_dttm is null or mdm_valid_to_dttm > sysdate)
      start with mdm_entity_type_id=parm_entity_type_id connect by prior mdm_entity_type_id=mdm_parent_id);

    open returnCursor for select mdm_last_mod_dttm, mdm_valid_to_dttm, '' as message  from mdm_entity_types where mdm_entity_type_id=parm_entity_type_id;
  EXCEPTION
  WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error('MDM_ENTITY_TYPES',null,parm_entity_type_id,null,'mdm_retireEntityType',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;


 PROCEDURE mdm_createColumns (parm_table_name   IN VARCHAR2,
                               parm_column_name IN VARCHAR2,
                               parm_datatype   IN VARCHAR2,  
                               parm_length      IN INTEGER,
                               parm_locale      IN VARCHAR2) AS
   
   dbDatatype  VARCHAR2(30); 
   colName     VARCHAR2(35);
   colType     VARCHAR2(50);  
   num_rows    INTEGER;
   strSql      VARCHAR2(100);
    
  BEGIN
    SELECT mdm_db_datatype INTO dbDatatype 
      FROM mdm_attr_datatypes 
     WHERE lower(mdm_attr_datatype) = lower(parm_datatype);
     
    colName := parm_column_name||'_'||parm_locale;
     
    IF (lower(dbDatatype) = 'varchar2' OR lower(dbDatatype) = 'nvarchar2') THEN
      colType := dbDatatype||'('||parm_length||')';
    ELSE
      colType := dbDatatype;
    END IF;  
    
    SELECT COUNT(1) INTO num_rows from user_tab_columns WHERE lower(column_name) = lower(colName) AND lower(table_name) = lower(parm_table_name);
    IF (num_rows = 0) THEN
       strSql := 'ALTER TABLE '||parm_table_name||' ADD '||colName||' '||colType;  
       EXECUTE IMMEDIATE strSql;              
    END IF;
    
  EXCEPTION
  WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error(parm_table_name,null,0,null,'mdm_createColumns',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;
  
  PROCEDURE mdm_entityIdExists (parm_entity_type  IN VARCHAR2,
                                parm_entity_id    IN INTEGER,
                                returnCursor      IN OUT refCursor) AS
  recordExists  INTEGER;
  strSql      VARCHAR2(100);
  
  BEGIN
    strSql := 'select 1 from mdm_'||parm_entity_type||'_tt where mdm_entity_id = :1';
    EXECUTE IMMEDIATE strSQL INTO recordExists USING parm_entity_id;
    
    OPEN returnCursor FOR SELECT recordExists AS record_exists FROM dual;    
  EXCEPTION
  WHEN NO_DATA_FOUND THEN
    OPEN returnCursor FOR SELECT 0 AS record_exists FROM dual;
  WHEN OTHERS THEN
      ROLLBACK;
      mdm_log_error(parm_entity_id,null,0,null,'mdm_entityIdExists',SQLCODE,SQLERRM,systimestamp);
      RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;  
  
  PROCEDURE mdm_dashboardCountsByDate (parm_entity_type  IN VARCHAR2,
                                       returnCursor      IN OUT refCursor) AS
    strSql   VARCHAR2(500);                                       
  BEGIN
    strSql := 'SELECT COUNT(*) records,mdm_src_sys_id,status,dtquery.mdm_valid_from_dttm,dtquery.mdm_valid_to_dttm
                 FROM (SELECT mdm_src_sys_id,mdm_valid_from_dttm,mdm_valid_to_dttm, 
                              CASE WHEN mdm_valid_to_dttm IS NULL THEN ''ACTIVE'' ELSE ''RETIRED'' END AS status
                         FROM mdm_'||parm_entity_type||'_tt) dtquery 
               GROUP BY mdm_src_sys_id,status,dtquery.mdm_valid_from_dttm,dtquery.mdm_valid_to_dttm';
    OPEN returnCursor FOR strSql;
  EXCEPTION
  WHEN OTHERS THEN
    mdm_log_error(parm_entity_type,null,0,null,'mdm_dashboardCountsByDate',SQLCODE,SQLERRM,systimestamp);
    RAISE_APPLICATION_ERROR(-20000,SQLERRM);    
  END;
  
  PROCEDURE mdm_dashboardGetActiveRetired (parm_entity_type IN VARCHAR2,
                                          parm_curr_dttm  IN TIMESTAMP,
                                          parm_active_retired IN VARCHAR2,
                                          returnCursor      IN OUT refCursor) AS 
    strSql   VARCHAR2(1000);   
    field    VARCHAR2(50);                                    
  BEGIN
    IF (parm_active_retired = 'ACTIVE') THEN
      field := 'mdm_valid_from_dttm';
    ELSE IF (parm_active_retired = 'RETIRED') THEN
            field := 'mdm_valid_to_dttm';
         END IF;
    END IF;     
    
    strSql := 'SELECT COUNT(*) as records,mdm_src_sys_id, addrange 
                 FROM (SELECT mdm_src_sys_id,
                              CASE WHEN '||field||' >= (:1-1) THEN ''DAY''
                                   WHEN '||field||' >= (:2-7) THEN ''WEEK''
                                   WHEN '||field||' >= (:3-30) THEN ''MONTH''
                                   WHEN '||field||' >= (:4-90) THEN ''QTR''
                                   WHEN '||field||' >= (:5-365) THEN ''YEAR''
                                   ELSE ''NOSCOPE'' END AS addrange
                         FROM mdm_'||parm_entity_type||'_tt) retquery
                WHERE ADDRANGE <> ''NOSCOPE''
               GROUP BY mdm_src_sys_id, addrange';
    OPEN returnCursor FOR strSql USING parm_curr_dttm,parm_curr_dttm,parm_curr_dttm,parm_curr_dttm,parm_curr_dttm;
  EXCEPTION
  WHEN OTHERS THEN
    mdm_log_error(parm_entity_type,null,0,null,'mdm_dashboardGetActiveRetired',SQLCODE,SQLERRM,systimestamp);
    RAISE_APPLICATION_ERROR(-20000,SQLERRM);    
  END;
  PROCEDURE mdm_batchLoadStats (parm_entity_type IN VARCHAR2,
                                parm_process_id  IN INTEGER,
                                returnCursor      IN OUT refCursor) AS
     strSql          VARCHAR2(1000);  
     recordsAdded    INTEGER;
     clustersAdded   INTEGER;
     clustersUpdated INTEGER;
     clustersRetired INTEGER;
     stagingId       INTEGER;
     startTime       DATE;
     endTime         DATE;                                    
  BEGIN
    SELECT mdm_staging_id,process_start_dttm,process_end_dttm
      INTO stagingId,startTime,endTime
      FROM mdm_process_control
     WHERE process_id = parm_process_id;    
    
    strSql := 'SELECT COUNT(1) FROM mdm_'||parm_entity_type||'_tt 
                WHERE mdm_staging_id = :1 and mdm_src_sys_id <> 1';
    EXECUTE IMMEDIATE strSql INTO recordsAdded USING stagingId;
    
    strSql := 'select count(distinct mdm_entity_cluster_id) from
                      (select mdm_entity_cluster_id,
                              min(nvl(mdm_valid_from_dttm,TO_DATE(''31.12.1000 00:00:00'', ''dd.mm.yyyy hh24:mi:ss'')))
                              over (partition by mdm_entity_cluster_id) min_valid_from_dttm
                         from mdm_'||parm_entity_type||'_tt where mdm_survivor=''Y'')
                where min_valid_from_dttm >= :1 and min_valid_from_dttm <= :2';    
    EXECUTE IMMEDIATE strSql INTO clustersAdded USING startTime, endTime;
    
    strSql := 'select count(1) from
                      (select mdm_entity_cluster_id,mdm_valid_to_dttm,
                              max(nvl(mdm_valid_to_dttm,TO_DATE(''31.12.9999 23:59:59'', ''dd.mm.yyyy hh24:mi:ss'')))
                               over (partition by mdm_entity_cluster_id) max_valid_to_dttm
                         from mdm_'||parm_entity_type||'_tt       
                        where mdm_survivor=''Y'')
                where mdm_valid_to_dttm <> max_valid_to_dttm
                  and mdm_valid_to_dttm >= :1 and mdm_valid_to_dttm <= :2';
    EXECUTE IMMEDIATE strSql INTO clustersUpdated USING startTime, endTime;
    
    strSql := 'select count(distinct mdm_entity_cluster_id) from
                      (select mdm_entity_cluster_id,
                              max(nvl(mdm_valid_to_dttm,TO_DATE(''31.12.9999 23:59:59'', ''dd.mm.yyyy hh24:mi:ss'')))
                              over (partition by mdm_entity_cluster_id) max_valid_to_dttm
                         from mdm_'||parm_entity_type||'_tt 
                        where mdm_survivor=''Y'')
                where max_valid_to_dttm >= :1 and max_valid_to_dttm <= :2';
    EXECUTE IMMEDIATE strSql INTO clustersRetired USING startTime, endTime;
        
    OPEN returnCursor FOR SELECT recordsAdded as records_added, clustersAdded as clusters_added, clustersUpdated as clusters_updated,
                                 clustersRetired as clusters_retired from dual;
  EXCEPTION
  WHEN OTHERS THEN
    mdm_log_error(parm_entity_type,null,0,null,'mdm_batchLoadStats',SQLCODE,SQLERRM,systimestamp);
    RAISE_APPLICATION_ERROR(-20000,SQLERRM);    
  END;   
  
  PROCEDURE mdm_dashboardCountsByStatus (parm_entity_type IN VARCHAR2,
                                returnCursor      IN OUT refCursor) AS
    strSql   VARCHAR2(500);                                       
  BEGIN
    strSql := 'SELECT COUNT(*) records, mdm_src_sys_id, status
                 FROM (SELECT mdm_src_sys_id,
                              CASE WHEN mdm_valid_to_dttm IS NULL THEN ''ACTIVE''
                               ELSE ''RETIRED'' END AS status
                         FROM mdm_'||parm_entity_type||'_tt) rcquery
               GROUP BY mdm_src_sys_id, status';
               
    OPEN returnCursor FOR strSql;
  EXCEPTION
  WHEN OTHERS THEN
    mdm_log_error(parm_entity_type,null,0,null,'mdm_dashboardCountsByStatus',SQLCODE,SQLERRM,systimestamp);
    RAISE_APPLICATION_ERROR(-20000,SQLERRM);    
  END;  
  
  PROCEDURE mdm_dashboardClusterSize (parm_entity_type IN VARCHAR2,
                                      returnCursor      IN OUT refCursor) AS         
    strSql   VARCHAR2(500);                                       
  BEGIN
    strSql := 'SELECT MAX(records) AS maxct, MIN(records) AS minct, AVG(CAST(records AS REAL)) AS avsize, SUM(records) AS record_sum, COUNT(records) AS record_count
                 FROM (SELECT COUNT(*) AS records, mdm_entity_cluster_id
                         FROM mdm_'||parm_entity_type||'_tt
                        WHERE mdm_valid_to_dttm IS NULL AND mdm_survivor <> ''Y''
                       GROUP BY  mdm_entity_cluster_id ) clusquery';
               
    OPEN returnCursor FOR strSql;
  EXCEPTION
  WHEN OTHERS THEN
    mdm_log_error(parm_entity_type,null,0,null,'mdm_dashboardClusterSize',SQLCODE,SQLERRM,systimestamp);
    RAISE_APPLICATION_ERROR(-20000,SQLERRM);    
  END;
  
  PROCEDURE mdm_getClusterHistory (parm_entity_type IN VARCHAR2,
                            parm_cluster_id IN INTEGER,
                            parm_cluster_label IN VARCHAR2,
                            returnCursor IN OUT refCursor) AS
    strSql   VARCHAR2(6000);
  BEGIN
    -- Start wrapper query
    strSql := 'SELECT vw.mdm_entity_id,ss.mdm_src_sys_name as Source_System,vw.mdm_src_sys_rec_id,vw.label,vw.modified_by,vw.action,vw.modified_date,vw.user_comment
                 FROM mdm_src_sys ss,(';

    -- Current cluster members insert history
    strSql := strSql||'SELECT tt.mdm_entity_id,tt.mdm_src_sys_id,tt.mdm_src_sys_rec_id,tt.'||parm_cluster_label||' as Label,pc.process_user AS Modified_By,''INSERT'' AS Action,tt.mdm_valid_from_dttm AS Modified_Date,null AS User_Comment
                   FROM mdm_process_control pc,
                        mdm_'||parm_entity_type||'_tt tt,
                       (SELECT mdm_entity_id
                           FROM mdm_'||parm_entity_type||'_tt
                          WHERE mdm_entity_cluster_id = :1
                            AND mdm_entity_id NOT IN (SELECT DISTINCT tt.mdm_entity_id
                                                        FROM mdm_'||parm_entity_type||'_tt tt, mdm_cluster_member_history cmh                        
                                                       WHERE tt.mdm_entity_cluster_id = :2
                                                         AND tt.mdm_entity_id = cmh.mdm_entity_id)
                         UNION
                         SELECT cmh.mdm_entity_id
                           FROM mdm_cluster_member_history cmh
                          WHERE cmh.mdm_entity_cluster_id = :3
                            AND cmh.mdm_entity_id NOT IN (SELECT cmh.mdm_entity_id
                                                            FROM mdm_cluster_member_history cmh,
                                                                 mdm_cluster_member_history prev  
                                                           WHERE cmh.mdm_entity_cluster_id = :4
                                                             AND cmh.mdm_entity_id = prev.mdm_entity_id
                                                             AND prev.mdm_modified_dttm < cmh.mdm_modified_dttm)) ttid                        
                  WHERE ttid.mdm_entity_id = tt.mdm_entity_id
                    AND tt.mdm_staging_id = pc.mdm_staging_id
                    AND pc.process_name = ''MAKE DATA LIVE''  ';

    -- Current cluster members retire history
    strSql := strSql||' UNION SELECT al.record_id AS mdm_entity_id,tt.mdm_src_sys_id,tt.mdm_src_sys_rec_id,tt.'||parm_cluster_label||' AS Label,al.mdm_modified_by AS Modified_By,al.user_action AS Action,al.modified_dttm AS Modified_Date,null AS User_Comment
               FROM mdm_'||parm_entity_type||'_al al,mdm_'||parm_entity_type||'_tt tt
              WHERE tt.mdm_entity_cluster_id = :5 AND tt.mdm_entity_id = al.record_id ';

    -- Previous cluster members that have been moved out or collapsed into another cluster
    strSql := strSql||' UNION SELECT cmh.mdm_entity_id,tt.mdm_src_sys_id,tt.mdm_src_sys_rec_id,tt.'||parm_cluster_label||' as Label,null AS Modified_By,CASE WHEN (cmh.mdm_reason = ''M'' OR cmh.mdm_reason = ''R'') THEN ''MOVED (OUT)'' WHEN (cmh.mdm_reason = ''C'') THEN ''CLUSTER COLLAPSE (OUT)'' END AS Action,
                              cmh.mdm_modified_dttm AS Modified_Date,mdm_comment AS User_Comment
                         FROM mdm_cluster_member_history cmh,mdm_'||parm_entity_type||'_tt tt
                        WHERE cmh.mdm_entity_cluster_id = :6 AND tt.mdm_entity_id = cmh.mdm_entity_id ';

    -- Current cluster members that have moved in or collapsed from another cluster
    strSql := strSql||' UNION SELECT cmh.mdm_entity_id,tt.mdm_src_sys_id,tt.mdm_src_sys_rec_id,tt.'||parm_cluster_label||' as Label,null AS Modified_By,CASE WHEN (cmh.mdm_reason = ''M'' OR cmh.mdm_reason = ''R'') THEN ''MOVED (IN)'' WHEN (cmh.mdm_reason = ''C'') THEN ''CLUSTER COLLAPSE (IN)'' END AS Action,
                           cmh.mdm_modified_dttm AS Modified_Date, cmh.mdm_comment AS User_Comment
                      FROM mdm_cluster_member_history cmh
                     INNER JOIN mdm_'||parm_entity_type||'_tt tt ON tt.mdm_entity_id = cmh.mdm_entity_id                      
                     WHERE tt.mdm_entity_cluster_id = :7
                       AND cmh.mdm_valid_to_dttm IS NULL ';

    -- Previous cluster members that have moved in or collapsed from another cluster and have sinced been moved out or collapsed into a different cluster
    strSql := strSql||' UNION SELECT cmh.mdm_entity_id,tt.mdm_src_sys_id,tt.mdm_src_sys_rec_id,tt.'||parm_cluster_label||' AS Label,null AS Modified_By,CASE WHEN (cmh.mdm_reason = ''M'' OR cmh.mdm_reason = ''R'') THEN ''MOVED (IN)'' WHEN (cmh.mdm_reason = ''C'') THEN ''CLUSTER COLLAPSE (IN)'' END mdm_reason,
                              cmh.mdm_modified_dttm AS Modified_Date, cmh.mdm_comment AS User_Comment
                         FROM mdm_cluster_member_history cmh,mdm_'||parm_entity_type||'_tt tt,
                              (SELECT cmh1.mdm_entity_id,max(cmh1.mdm_modified_dttm) over (partition by cmh1.mdm_entity_id) mdm_modified_dttm
                                 FROM mdm_cluster_member_history cmh1,mdm_cluster_member_history cmh2
                                WHERE cmh1.mdm_entity_cluster_id <> :8 AND cmh1.mdm_modified_dttm < cmh2.mdm_modified_dttm
                                  AND cmh1.mdm_entity_id = cmh2.mdm_entity_id AND cmh2.mdm_entity_cluster_id = :9) temp
                        WHERE temp.mdm_entity_id = cmh.mdm_entity_id AND temp.mdm_modified_dttm = cmh.mdm_modified_dttm
                          AND cmh.mdm_entity_id = tt.mdm_entity_id ';

    -- Close wrapper query
    strSql := strSql||') vw WHERE vw.mdm_src_sys_id = ss.mdm_src_sys_id ORDER BY modified_date';

    OPEN returnCursor FOR strSql USING parm_cluster_id,parm_cluster_id,parm_cluster_id,parm_cluster_id,parm_cluster_id,parm_cluster_id,parm_cluster_id,parm_cluster_id,parm_cluster_id;
  EXCEPTION
  WHEN OTHERS THEN
    mdm_log_error(parm_entity_type,'mdm_entity_cluster_id',parm_cluster_id,null,'mdm_getClusterHistory',SQLCODE,SQLERRM,systimestamp);
    RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;
  
  PROCEDURE mdm_createStagingTables (parm_entity_type_id  IN INTEGER,
                                     parm_entity_type     IN VARCHAR2,
                                     parm_staging_id      IN INTEGER DEFAULT NULL) AS
    strSql   VARCHAR2(1000);
    entitySt_tbl  VARCHAR2(30);
    stg_tbl        VARCHAR2(30);
    entityCc_tbl  VARCHAR2(30);
    err_location INTEGER;
    num_rows INTEGER;
    attr_name varchar2(50);
    attr_datatype varchar2(50);
    attr_nullable varchar2(10);
    attr_defn varchar2(100);
    attr_encrypt char(1);
    parent_id integer;
    ccColName  VARCHAR2(30);
    err_staging_id INTEGER;

    CURSOR get_attrs IS select a.mdm_attr_name,a.mdm_encrypt_flag,a.mdm_parent_attr_id,
      case
        when (t.mdm_db_datatype='VARCHAR2' OR t.mdm_db_datatype='NVARCHAR2') then t.mdm_db_datatype||'('||case when a.mdm_attr_length>0 then a.mdm_attr_length else 1 end||')'
        else t.mdm_db_datatype end as datatype,
      case
        when a.mdm_required='Y' or 
		a.mdm_attr_id in 
			(select mdm_label_attr_id from mdm_entity_types
                                       where ((mdm_valid_to_dttm > systimestamp or mdm_valid_to_dttm is null) and mdm_label_attr_id IS NOT NULL)
                                       start with mdm_entity_type_id = parm_entity_type_id
                                       connect by prior mdm_parent_id = mdm_entity_type_id)
		then 'NOT NULL'
        else 'NULL'end as nullable
      from mdm_attrs a, mdm_attr_datatypes t
      where a.mdm_attr_id > 0 and a.mdm_attr_datatype_id=t.mdm_attr_datatype_id
        and a.mdm_entity_type_id in (select mdm_entity_type_id from mdm_entity_types
                                       where (mdm_valid_to_dttm > systimestamp or mdm_valid_to_dttm is null)
                                       start with mdm_entity_type_id = parm_entity_type_id
                                       connect by prior mdm_parent_id = mdm_entity_type_id)
        and a.mdm_valid_from_dttm <= systimestamp
        and (a.mdm_valid_to_dttm > systimestamp or a.mdm_valid_to_dttm is null)
       order by a.mdm_attr_name;
    CURSOR get_clusterCols IS SELECT DISTINCT vw.mdm_attr_name, vw.datatype, vw.nullable
         FROM (SELECT ccon.mdm_entity_type_id,
                  a.mdm_attr_name,
                  ccon.mdm_sort_order,
                  CASE
                   WHEN (ad.mdm_db_datatype='VARCHAR2' OR ad.mdm_db_datatype='NVARCHAR2') THEN ad.mdm_db_datatype||'('||CASE WHEN a.mdm_attr_length>0 THEN a.mdm_attr_length ELSE 1 END||')'
                   ELSE ad.mdm_db_datatype END AS datatype,
                  CASE
                   WHEN a.mdm_required='Y' OR
				   a.mdm_attr_id in 
									 (SELECT mdm_label_attr_id
                                           FROM mdm_entity_types
                                          WHERE ((mdm_valid_to_dttm IS NULL OR mdm_valid_to_dttm > systimestamp) AND mdm_label_attr_id IS NOT NULL)
                                     START WITH mdm_entity_type_id = parm_entity_type_id CONNECT BY PRIOR mdm_parent_id=mdm_entity_type_id)
				   THEN 'NOT NULL'
                   ELSE 'NULL'END AS nullable
              FROM mdm_cluster_conditions ccon,
                   mdm_cluster_criteria ccri,
                   mdm_attrs a,
                   mdm_attr_datatypes ad
             WHERE ccon.mdm_cluster_condition_id = ccri.mdm_cluster_condition_id
               AND ccri.mdm_attr_id = a.mdm_attr_id
               AND a.mdm_valid_from_dttm <= systimestamp
               AND (a.mdm_valid_to_dttm > systimestamp OR a.mdm_valid_to_dttm IS NULL)
               AND a.mdm_attr_datatype_id = ad.mdm_attr_datatype_id) vw
       WHERE vw.mdm_entity_type_id IN (SELECT mdm_entity_type_id
                                           FROM mdm_entity_types
                                          WHERE (mdm_valid_to_dttm IS NULL OR mdm_valid_to_dttm > systimestamp)
                                     START WITH mdm_entity_type_id = parm_entity_type_id CONNECT BY PRIOR mdm_parent_id=mdm_entity_type_id)
       ORDER BY vw.mdm_attr_name;
  BEGIN
    IF (parm_staging_id IS NULL) THEN
      entitySt_tbl := 'MDM_'||parm_entity_type||'_ST';
      entityCc_tbl := 'MDM_'||parm_entity_type||'_CC';
      stg_tbl := 'MDM_STAGING';
      err_staging_id := 0;
    ELSE
      entitySt_tbl := 'MDM_BULK_ST_'||parm_staging_id;
      entityCc_tbl := 'MDM_BULK_CC_'||parm_staging_id;
      stg_tbl := 'MDM_STAGING_'||parm_staging_id;
      err_staging_id := parm_staging_id;
    END IF;

      -- if the staging table doesn't already exist, create it.
      EXECUTE IMMEDIATE 'SELECT COUNT(1) FROM user_tables WHERE lower(table_name) = lower(:st_name)' INTO num_rows USING entitySt_tbl;
      IF (num_rows = 0) THEN
          err_location:= 10;
          EXECUTE IMMEDIATE 'CREATE TABLE ' || entitySt_tbl || '(
            MDM_STAGING_ID INTEGER NOT NULL,
            ROW_ID INTEGER NOT NULL,
            MDM_ENTITY_CLUSTER_ID INTEGER NULL,
            MDM_ENTITY_CLUSTER_NAME  NVARCHAR2(100) NOT NULL,
            MDM_SURVIVOR CHAR(1) NOT NULL,
            MATCH_TYPE INTEGER NOT NULL,
            CID INTEGER NOT NULL,
            ROW_PROCESSED CHAR(1) DEFAULT ''N'' NOT NULL,
            MDM_SRC_SYS_ID INTEGER NOT NULL,
            MDM_SRC_SYS_REC_ID  NVARCHAR2(200),
            MDM_LANGUAGE_ID INTEGER NOT NULL)';
      END IF;

          err_location:= 20;
          -- Add columnns
          OPEN get_attrs;
          LOOP
          FETCH get_attrs into attr_name,attr_encrypt,parent_id,attr_datatype,attr_nullable;
          EXIT WHEN get_attrs%NOTFOUND;
             IF (attr_encrypt = 'Y' AND parent_id IS NULL) THEN
                 attr_datatype := 'RAW(1000)';
             END IF;

             attr_defn:=upper(attr_name)||' '||attr_datatype||' '||attr_nullable;

             SELECT COUNT(1) INTO num_rows FROM user_tab_columns WHERE lower(column_name) = lower(attr_name) AND lower(table_name) = lower(entitySt_tbl);
             IF (num_rows=0) THEN
                 strSQL:='ALTER TABLE '||entitySt_tbl||' ADD '||attr_defn;
                 EXECUTE IMMEDIATE strSQL;
             END IF;
          END LOOP;
          CLOSE get_attrs;

      -- if the staging table doesn't already exist, create it.
      EXECUTE IMMEDIATE 'select count(1) from USER_TABLES where lower(table_name) = lower(:st_name)' INTO num_rows USING entityCc_tbl;
      IF (num_rows = 0) THEN
          err_location:= 30;
          EXECUTE IMMEDIATE 'CREATE TABLE ' || entityCc_tbl || '(
            MDM_STAGING_ID INTEGER NOT NULL,
            ROW_ID INTEGER NOT NULL)';
      END IF;

          err_location:= 40;
          -- Add cluster columns
          OPEN get_clusterCols;
          LOOP
          FETCH get_clusterCols INTO ccColName,attr_datatype, attr_nullable;
          EXIT WHEN get_clusterCols%NOTFOUND;

           SELECT COUNT(1) INTO num_rows FROM user_tab_columns WHERE lower(column_name) = lower(ccColName) AND lower(table_name) = lower(entityCc_tbl);

           attr_defn:= upper(ccColName)||' '||attr_datatype||' '||attr_nullable;

           IF (num_rows=0) THEN
                strSQL:='ALTER TABLE '||entityCc_tbl||' ADD '||attr_defn;
                EXECUTE IMMEDIATE strSQL;
           END IF;
          END LOOP;
          CLOSE get_clusterCols;

      -- if the staging table doesn't already exist, create it.
      EXECUTE IMMEDIATE 'select count(1) from USER_TABLES where lower(table_name) = lower(:st_name)' INTO num_rows USING stg_tbl;
      IF (num_rows = 0) THEN
       err_location:= 50;
          EXECUTE IMMEDIATE 'CREATE TABLE '||stg_tbl||' (
                               MDM_STAGING_ID           INTEGER NOT NULL,
                               MDM_ENTITY_ID            INTEGER NOT NULL,
                               MDM_ENTITY_CLUSTER_ID    INTEGER,
                               MDM_ENTITY_CLUSTER_NAME  NVARCHAR2(100) NOT NULL,
                               MATCH_TYPE               INTEGER NOT NULL,
                               OLD_CLUSTER_ID           INTEGER,
                               ROW_PROCESSED            CHAR(1) DEFAULT ''N'' NOT NULL)';
      END IF;
  EXCEPTION
  WHEN OTHERS THEN
    mdm_log_error(parm_entity_type,'mdm_staging_id',err_staging_id,null,'mdm_createStagingTables',SQLCODE,'Location:'||err_location||':'||SQLERRM,systimestamp);
    RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;

  PROCEDURE mdm_createStagingIndices (parm_entity_type     IN VARCHAR2,
                                      parm_staging_id      IN INTEGER DEFAULT NULL) AS
    entitySt_tbl  VARCHAR2(30);
    entityCc_tbl  VARCHAR2(30);
    entityTt_tbl  VARCHAR2(30);
    stg_tbl        VARCHAR2(30);
    num_rows INTEGER;
    tt_num_rows INTEGER;
    st_num_rows INTEGER;
    cc_num_rows INTEGER;
    constraintName VARCHAR2(30);
    indexName VARCHAR2(30);
    tblNameApp VARCHAR2(23);
    stgTblNameApp VARCHAR2(23);
    tt_index_cols VARCHAR2(500);
    st_index_cols VARCHAR2(500);
    cc_index_cols VARCHAR2(500);
    createIdx BOOLEAN;
    index_id INTEGER;
    attr_name VARCHAR2(50);
    stg_idx  INTEGER;
    err_location INTEGER;
    err_stg_id INTEGER;
    idx_exception EXCEPTION;
    CURSOR get_indices IS SELECT mdm_index_id, mdm_attr_name
            FROM mdm_entity_type_indices
           WHERE LOWER(mdm_entity_type) = LOWER(parm_entity_type)
        ORDER BY mdm_index_id,mdm_index_column_order;
    CURSOR get_ttIndices IS SELECT index_name FROM user_indexes
             WHERE LOWER(table_name) = LOWER(entityTt_tbl)
               AND LOWER(index_name) LIKE LOWER('IDT_'||parm_entity_type||'_%');
    CURSOR get_stIndices IS SELECT index_name FROM user_indexes
             WHERE LOWER(table_name) = LOWER(entitySt_tbl)
               AND LOWER(index_name) LIKE LOWER('IDS_'||parm_entity_type||'_%');
    CURSOR get_ccIndices IS SELECT index_name FROM user_indexes
             WHERE LOWER(table_name) = LOWER(entityCc_tbl)
               AND LOWER(index_name) LIKE LOWER('IDC_'||parm_entity_type||'_%');
  BEGIN
    IF (parm_staging_id IS NULL) THEN
      tblNameApp := parm_entity_type;
      stgTblNameApp := '';
      entitySt_tbl := 'MDM_'||parm_entity_type||'_ST';
      entityCc_tbl := 'MDM_'||parm_entity_type||'_CC';
      stg_tbl := 'MDM_STAGING';
      err_stg_id := 0;
    ELSE
      tblNameApp := 'STG'||parm_staging_id;
      stgTblNameApp := '_STG'||parm_staging_id;
      entitySt_tbl := 'MDM_BULK_ST_'||parm_staging_id;
      entityCc_tbl := 'MDM_BULK_CC_'||parm_staging_id;
      stg_tbl := 'MDM_STAGING_'||parm_staging_id;
      err_stg_id := parm_staging_id;
    END IF;
    entityTt_tbl := 'MDM_'||parm_entity_type||'_TT';

    -- Add st constraints
    err_location := 10;
    constraintName := 'FKL_ST_'||tblNameApp;
    SELECT COUNT(1) INTO num_rows FROM user_constraints WHERE lower(constraint_name) = lower(constraintName) AND lower(table_name) = lower(entitySt_tbl);
    IF (num_rows = 0) THEN
      EXECUTE IMMEDIATE 'ALTER TABLE ' || entitySt_tbl || ' ADD CONSTRAINT '||constraintName||'
          FOREIGN KEY (MDM_LANGUAGE_ID) REFERENCES MDM_LANGUAGES(MDM_LANGUAGE_ID)';
    END IF;

    -- Add st indices
    err_location := 20;
    indexName := 'IX_CID_'||tblNameApp;
    SELECT COUNT(1) INTO num_rows FROM user_indexes WHERE lower(index_name) = lower(indexName) AND lower(table_name) = lower(entitySt_tbl);
    IF (num_rows = 0) THEN
      EXECUTE IMMEDIATE 'CREATE INDEX '||indexName||' ON ' || entitySt_tbl || ' (CID)';
    END IF;
    err_location := 30;
    indexName := 'ST_MT_'||tblNameApp;
    SELECT COUNT(1) INTO num_rows FROM user_indexes WHERE lower(index_name) = lower(indexName) AND lower(table_name) = lower(entitySt_tbl);
    IF (num_rows = 0) THEN
      EXECUTE IMMEDIATE 'CREATE INDEX '||indexName||' ON ' || entitySt_tbl || ' (MDM_STAGING_ID,MATCH_TYPE)';
    END IF;
    err_location := 50;
    indexName := 'ST_RID_'||tblNameApp;
    SELECT COUNT(1) INTO num_rows FROM user_indexes WHERE lower(index_name) = lower(indexName) AND lower(table_name) = lower(entitySt_tbl);
    IF (num_rows = 0) THEN
      EXECUTE IMMEDIATE 'CREATE INDEX '||indexName||' ON ' || entitySt_tbl || ' (ROW_ID)';
    END IF;

    -- Add staging indices
    err_location := 60;
    indexName := 'SG_CID'||stgTblNameApp;
    SELECT COUNT(1) INTO num_rows FROM user_indexes WHERE lower(index_name) = lower(indexName) AND lower(table_name) = lower(stg_tbl);
    IF (num_rows = 0) THEN
      EXECUTE IMMEDIATE 'CREATE INDEX '||indexName||' ON ' || stg_tbl || ' (MDM_ENTITY_CLUSTER_ID)';
    END IF;
    err_location := 70;
    indexName := 'SG_MT'||stgTblNameApp;
    SELECT COUNT(1) INTO num_rows FROM user_indexes WHERE lower(index_name) = lower(indexName) AND lower(table_name) = lower(stg_tbl);
    IF (num_rows = 0) THEN
      EXECUTE IMMEDIATE 'CREATE INDEX '||indexName||' ON ' || stg_tbl || ' (MDM_STAGING_ID,MATCH_TYPE)';
    END IF;
    err_location := 80;
    indexName := 'SG_EID'||stgTblNameApp;
    SELECT COUNT(1) INTO num_rows FROM user_indexes WHERE lower(index_name) = lower(indexName) AND lower(table_name) = lower(stg_tbl);
    IF (num_rows = 0) THEN
      EXECUTE IMMEDIATE 'CREATE INDEX '||indexName||' ON ' || stg_tbl || ' (MDM_ENTITY_ID)';
    END IF;

    -- Drop any existing entity indices
    err_location:= 85;
    IF (parm_staging_id IS NULL) THEN
      OPEN get_ttIndices;
        LOOP
          FETCH get_ttIndices INTO indexName;
          EXIT WHEN get_ttIndices%NOTFOUND;
          EXECUTE IMMEDIATE 'DROP INDEX '||indexName;
        END LOOP;
      CLOSE get_ttIndices;
    END IF;

    err_location:= 86;
    OPEN get_stIndices;
      LOOP
        FETCH get_stIndices INTO indexName;
        EXIT WHEN get_stIndices%NOTFOUND;
        EXECUTE IMMEDIATE 'DROP INDEX '||indexName;
      END LOOP;
    CLOSE get_stIndices;

    err_location:= 87;
    OPEN get_ccIndices;
      LOOP
        FETCH get_ccIndices INTO indexName;
        EXIT WHEN get_ccIndices%NOTFOUND;
        EXECUTE IMMEDIATE 'DROP INDEX '||indexName;
      END LOOP;
    CLOSE get_ccIndices;

    -- Add entity indices
    err_location := 90;
    tt_index_cols := '';
    st_index_cols := '';
    cc_index_cols := '';
    createIdx := FALSE;
    OPEN get_indices;
      LOOP
        FETCH get_indices INTO index_id,attr_name;
        EXIT WHEN get_indices%NOTFOUND;

        SELECT COUNT(1) INTO tt_num_rows FROM user_tab_columns WHERE lower(column_name) = lower(attr_name) AND lower(table_name) = lower(entityTt_tbl);
        SELECT COUNT(1) INTO st_num_rows FROM user_tab_columns WHERE lower(column_name) = lower(attr_name) AND lower(table_name) = lower(entitySt_tbl);
        SELECT COUNT(1) INTO cc_num_rows FROM user_tab_columns WHERE lower(column_name) = lower(attr_name) AND lower(table_name) = lower(entityCc_tbl);

        IF (tt_num_rows > 0 OR st_num_rows > 0 OR cc_num_rows > 0) THEN
          IF (stg_idx IS NULL) OR (stg_idx = index_id) THEN
              createIdx := FALSE;
          ELSE
              createIdx := TRUE;
          END IF;

          IF (createIdx) THEN
            IF (parm_staging_id IS NULL) THEN
              err_location := 100;
              indexName := 'IDT_'||tblNameApp||'_'||stg_idx;
              SELECT COUNT(1) INTO num_rows FROM user_indexes WHERE lower(index_name) = lower(indexName) AND lower(table_name) = lower(entityTt_tbl);
              IF (num_rows = 0) AND (length(ltrim(rtrim(tt_index_cols))) > 0) THEN
                BEGIN
                  EXECUTE IMMEDIATE 'CREATE INDEX '||indexName||' ON '||entityTt_tbl||' ('||tt_index_cols||')';  
                EXCEPTION
                  WHEN OTHERS THEN
                    IF (SQLCODE = '-1408') THEN
                      GOTO st_index;
                    ELSE 
                      RAISE idx_exception;
                    END IF;
                END;               
              END IF;
            END IF;
            <<st_index>>
            err_location := 110;
            indexName := 'IDS_'||tblNameApp||'_'||stg_idx;
            SELECT COUNT(1) INTO num_rows FROM user_indexes WHERE lower(index_name) = lower(indexName) AND lower(table_name) = lower(entitySt_tbl);
            IF (num_rows = 0) AND (length(ltrim(rtrim(st_index_cols))) > 0) THEN
              BEGIN
                EXECUTE IMMEDIATE 'CREATE INDEX '||indexName||' ON '||entitySt_tbl||' ('||st_index_cols||')';
              EXCEPTION
                WHEN OTHERS THEN
                  IF (SQLCODE = '-1408') THEN
                    GOTO cc_index;
                  ELSE 
                    RAISE idx_exception;
                  END IF;
              END;
            END IF;
            <<cc_index>>
            err_location := 120;
            indexName := 'IDC_'||tblNameApp||'_'||stg_idx;
            SELECT COUNT(1) INTO num_rows FROM user_indexes WHERE lower(index_name) = lower(indexName) AND lower(table_name) = lower(entityCc_tbl);
            IF (num_rows = 0) AND (length(ltrim(rtrim(cc_index_cols))) > 0) THEN
              BEGIN
                EXECUTE IMMEDIATE 'CREATE INDEX '||indexName||' ON '||entityCc_tbl||' ('||cc_index_cols||')';
              EXCEPTION
                WHEN OTHERS THEN
                  IF (SQLCODE = '-1408') THEN
                    GOTO idx_end;
                  ELSE 
                    RAISE idx_exception;
                  END IF;
              END;
            END IF;
            <<idx_end>>
            tt_index_cols := '';
            st_index_cols := '';
            cc_index_cols := '';
          END IF;

          IF (length(ltrim(rtrim(tt_index_cols))) > 0) THEN
            tt_index_cols := tt_index_cols||',';
          END IF;
          IF (length(ltrim(rtrim(st_index_cols))) > 0) THEN
            st_index_cols := st_index_cols||',';
          END IF;
          IF (length(ltrim(rtrim(cc_index_cols))) > 0) THEN
            cc_index_cols := cc_index_cols||',';
          END IF;
          
          stg_idx := index_id;
          
          IF (tt_num_rows > 0) THEN
            tt_index_cols := tt_index_cols||attr_name;
          END IF;
          IF (st_num_rows > 0) THEN
            st_index_cols := st_index_cols||attr_name;
          END IF;
          IF (cc_num_rows > 0) THEN
            cc_index_cols := cc_index_cols||attr_name;
          END IF;
        END IF;
      END LOOP;
      CLOSE get_indices;

      IF (length(ltrim(rtrim(tt_index_cols))) > 0) OR (length(ltrim(rtrim(st_index_cols))) > 0) OR (length(ltrim(rtrim(cc_index_cols))) > 0) THEN
        IF (parm_staging_id IS NULL) THEN
          err_location := 130;
          indexName := 'IDT_'||tblNameApp||'_'||index_id;
          SELECT COUNT(1) INTO num_rows FROM user_indexes WHERE lower(index_name) = lower(indexName) AND lower(table_name) = lower(entityTt_tbl);
          IF (num_rows = 0) AND (length(ltrim(rtrim(tt_index_cols))) > 0) THEN    
            BEGIN         
              EXECUTE IMMEDIATE 'CREATE INDEX '||indexName||' ON '||entityTt_tbl||' ('||tt_index_cols||')';
            EXCEPTION
              WHEN OTHERS THEN
                IF (SQLCODE = '-1408') THEN
                  GOTO end_st_index;
                ELSE 
                  RAISE idx_exception;
                END IF;
            END;
          END IF;
        END IF;
        <<end_st_index>>
        err_location := 140;
        indexName := 'IDS_'||tblNameApp||'_'||stg_idx;
        SELECT COUNT(1) INTO num_rows FROM user_indexes WHERE lower(index_name) = lower(indexName) AND lower(table_name) = lower(entitySt_tbl);
        IF (num_rows = 0) AND (length(ltrim(rtrim(st_index_cols))) > 0) THEN
          BEGIN
            EXECUTE IMMEDIATE 'CREATE INDEX '||indexName||' ON '||entitySt_tbl||' ('||st_index_cols||')';
          EXCEPTION
            WHEN OTHERS THEN
              IF (SQLCODE = '-1408') THEN
                GOTO end_cc_index;
              ELSE 
                RAISE idx_exception;
              END IF;
          END;
        END IF;
        <<end_cc_index>>
        err_location := 150;
        indexName := 'IDC_'||tblNameApp||'_'||stg_idx;
        SELECT COUNT(1) INTO num_rows FROM user_indexes WHERE lower(index_name) = lower(indexName) AND lower(table_name) = lower(entityCc_tbl);
        IF (num_rows = 0) AND (length(ltrim(rtrim(cc_index_cols))) > 0) THEN
          BEGIN
            EXECUTE IMMEDIATE 'CREATE INDEX '||indexName||' ON '||entityCc_tbl||' ('||cc_index_cols||')';
          EXCEPTION
            WHEN OTHERS THEN
              IF (SQLCODE = '-1408') THEN
                GOTO end_index_creation;
              ELSE 
                RAISE idx_exception;
              END IF;
          END;
        END IF;
        <<end_index_creation>>
        null;
      END IF;

  EXCEPTION
  WHEN idx_exception THEN
    mdm_log_error(parm_entity_type,'mdm_staging_id',err_stg_id,null,'mdm_createStagingIndices',SQLCODE,'Location:'||err_location||':'||SQLERRM,systimestamp);
    RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  WHEN OTHERS THEN
    mdm_log_error(parm_entity_type,'mdm_staging_id',err_stg_id,null,'mdm_createStagingIndices',SQLCODE,'Location:'||err_location||':'||SQLERRM,systimestamp);
    RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;
  
  PROCEDURE mdm_deleteProcessedRecords (parm_entity_type IN VARCHAR2,
                                        parm_staging_id   IN INTEGER,
                                        parm_startCluster IN INTEGER,
                                        parm_endCluster   IN INTEGER,
                                        parm_processType  IN VARCHAR2,
                                        parm_increment    IN INTEGER) AS
    err_location INTEGER;
    strSQL       VARCHAR2(2000);
    firstIdx     INTEGER;
    lastIdx      INTEGER;
    stgTbl       VARCHAR2(30);
    entityStgTbl VARCHAR2(30);
  BEGIN
    IF (lower(parm_processType) = lower('BULK')) THEN
      stgTbl := 'MDM_STAGING_'||parm_staging_id;
      entityStgTbl := 'MDM_BULK_ST_'||parm_staging_id;
    ELSE
      stgTbl := 'MDM_STAGING';
      entityStgTbl := 'MDM_'||parm_entity_type||'_ST';
    END IF;

    IF (parm_endCluster IS NOT NULL) THEN
          firstIdx:=parm_startCluster;
          lastIdx:=firstIdx+parm_increment;
          if (lastIdx > parm_endCluster) then
            lastIdx:=parm_endCluster;
          end if;
          while (firstIdx <= parm_endCluster) LOOP
            err_location := 10;
            strSQL:= 'DELETE /*+ NOLOGGING */ FROM '||stgTbl||'
             WHERE mdm_staging_id = :1
               AND mdm_entity_cluster_id >= :2 AND mdm_entity_cluster_id <= :3';
            EXECUTE IMMEDIATE strSQL USING parm_staging_id, firstIdx, lastIdx;

            err_location := 20;
            strSQL := 'DELETE /*+ NOLOGGING */ FROM '||entityStgTbl||
                      ' WHERE mdm_staging_id =:1 '||
                         'AND mdm_entity_cluster_id >= :2 AND mdm_entity_cluster_id <= :3';
            execute immediate strSQL using parm_staging_id,firstIdx,lastIdx;
            firstIdx:=lastIdx+1;
            lastIdx:=firstIdx+parm_increment;
            if (lastIdx > parm_endCluster) then
              lastIdx:=parm_endCluster;
            end if;
            COMMIT;
          END LOOP;
      END IF;
  EXCEPTION
  WHEN OTHERS THEN
    mdm_log_error(parm_entity_type,'mdm_staging_id',parm_staging_id,null,'mdm_deleteProcessedRecords',SQLCODE,'Location:'||err_location||':'||SQLERRM,systimestamp);
    RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;
  
  PROCEDURE mdm_archive (parm_entity_type IN VARCHAR2,
                         parm_curr_dttm IN TIMESTAMP,
                         parm_action IN VARCHAR2,
                         returnCursor IN OUT refCursor) AS
    err_location   INTEGER;
    strSQL       VARCHAR2(10000);
    TYPE tt_cursor IS REF CURSOR;
    tt_curs tt_cursor;
    entity_type_id INTEGER;
    tt_columns VARCHAR2(4000);
  BEGIN
    err_location := 10;
    IF (LOWER(parm_action) = LOWER('COUNT')) THEN
      strSQL := 'SELECT COUNT(1)AS archival_count
                   FROM mdm_'||parm_entity_type||'_tt
                  WHERE mdm_valid_to_dttm <= :1';
      OPEN returnCursor FOR strSQL using parm_curr_dttm;
    END IF;

    err_location := 20;
    IF (LOWER(parm_action) = LOWER('RELATIONSHIP_COUNT')) THEN
      strSQL := 'SELECT COUNT(*) AS relationship_count FROM
                  (SELECT DISTINCT rel.mdm_from_cluster_id, rel.mdm_to_cluster_id
                    FROM mdm_entity_rel rel, mdm_'||parm_entity_type||'_tt tt
                   WHERE rel.mdm_valid_to_dttm <= :1
                     AND rel.mdm_valid_from_dttm <> rel.mdm_valid_to_dttm
                     AND (tt.mdm_entity_cluster_id = rel.mdm_from_cluster_id OR tt.mdm_entity_cluster_id = rel.mdm_to_cluster_id)) t';
      OPEN returnCursor FOR strSQL using parm_curr_dttm;
    END IF;

    err_location := 30;
    IF (LOWER(parm_action) = LOWER('GET_AUDIT')) THEN
      strSQL := 'SELECT * FROM mdm_'||parm_entity_type||'_al
                  WHERE modified_dttm <= :1';
      OPEN returnCursor FOR strSQL using parm_curr_dttm;
    END IF;

    err_location := 40;
    IF (LOWER(parm_action) = LOWER('GET_HISTORY')) THEN
      strSQL := 'SELECT hist.* FROM mdm_cluster_member_history hist, mdm_'||parm_entity_type||'_tt tt
                  WHERE hist.mdm_entity_id = tt.mdm_entity_id
              AND tt.mdm_valid_to_dttm <= :1
              UNION 
             SELECT * FROM mdm_cluster_member_history
            WHERE EXISTS (SELECT mdm_entity_cluster_id 
                    FROM (SELECT mdm_entity_cluster_id,mdm_valid_to_dttm,
                             MAX(NVL(mdm_valid_to_dttm,TO_DATE(''31.12.9999 23:59:59'', ''dd.mm.yyyy hh24:mi:ss'')))
                                                 OVER (PARTITION BY mdm_entity_cluster_id) max_valid_to_dttm
                          FROM (SELECT mdm_entity_cluster_id,mdm_valid_to_dttm FROM mdm_'||parm_entity_type||'_tt 
                             WHERE mdm_survivor=''Y''
                                     AND (mdm_valid_to_dttm IS NULL OR mdm_valid_to_dttm <= :2)) tmp) tmp1
                     WHERE mdm_valid_to_dttm IS NOT NULL AND mdm_valid_to_dttm = max_valid_to_dttm
                         AND mdm_cluster_member_history.mdm_entity_cluster_id = mdm_entity_cluster_id)';
      OPEN returnCursor FOR strSQL using parm_curr_dttm,parm_curr_dttm;
    END IF;

    err_location := 50;
    IF (LOWER(parm_action) = LOWER('GET_RELATIONSHIPS')) THEN
      strSQL := 'SELECT rel.*
                  FROM mdm_entity_rel rel,
                      (SELECT DISTINCT rel.mdm_from_cluster_id, rel.mdm_to_cluster_id
                         FROM mdm_entity_rel rel, mdm_'||parm_entity_type||'_tt tt
                        WHERE rel.mdm_valid_to_dttm <= :1
                          AND rel.mdm_valid_from_dttm <> rel.mdm_valid_to_dttm
                          AND (tt.mdm_entity_cluster_id = rel.mdm_from_cluster_id OR tt.mdm_entity_cluster_id = rel.mdm_to_cluster_id)) tmp
                 WHERE rel.mdm_from_cluster_id = tmp.mdm_from_cluster_id
                   AND rel.mdm_to_cluster_id = tmp.mdm_to_cluster_id';
      OPEN returnCursor FOR strSQL using parm_curr_dttm;
    END IF;

    err_location := 60;
    IF (LOWER(parm_action) = LOWER('GET_MAPPINGS')) THEN
      strSQL := 'SELECT cm.*
                   FROM mdm_cluster_mapping cm,
                     (SELECT mdm_entity_cluster_id
                        FROM (SELECT mdm_entity_cluster_id,mdm_valid_to_dttm,
                                     MAX(NVL(mdm_valid_to_dttm,TO_DATE(''31.12.9999 23:59:59'', ''dd.mm.yyyy hh24:mi:ss'')))
                                     OVER (PARTITION BY mdm_entity_cluster_id) max_valid_to_dttm
                                FROM (SELECT mdm_entity_cluster_id, mdm_valid_to_dttm FROM mdm_'||parm_entity_type||'_tt
                                       WHERE mdm_survivor = ''Y'' AND (mdm_valid_to_dttm IS NULL OR mdm_valid_to_dttm <= :1)))
                       WHERE mdm_valid_to_dttm IS NOT NULL
                         AND mdm_valid_to_dttm = max_valid_to_dttm) ret_clusters
               WHERE cm.original_cluster_id = ret_clusters.mdm_entity_cluster_id
                  OR cm.current_cluster_id = ret_clusters.mdm_entity_cluster_id';
      OPEN returnCursor FOR strSQL using parm_curr_dttm;
    END IF;

    err_location := 70;
    IF (LOWER(parm_action) = LOWER('GET_CLUSTERS')) THEN
      strSQL := 'SELECT ec.*
                  FROM mdm_entity_clusters ec,
                      (SELECT mdm_entity_cluster_id
                          FROM (SELECT mdm_entity_cluster_id,mdm_valid_to_dttm,
                                       MAX(NVL(mdm_valid_to_dttm,TO_DATE(''31.12.9999 23:59:59'', ''dd.mm.yyyy hh24:mi:ss'')))
                                       OVER (PARTITION BY mdm_entity_cluster_id) max_valid_to_dttm
                                  FROM (SELECT mdm_entity_cluster_id, mdm_valid_to_dttm FROM mdm_'||parm_entity_type||'_tt
                                         WHERE mdm_survivor = ''Y'' AND (mdm_valid_to_dttm IS NULL OR mdm_valid_to_dttm <= :1)))
                         WHERE mdm_valid_to_dttm IS NOT NULL
                           AND mdm_valid_to_dttm = max_valid_to_dttm) ret_clusters
                 WHERE ec.mdm_entity_cluster_id = ret_clusters.mdm_entity_cluster_id';
      OPEN returnCursor FOR strSQL using parm_curr_dttm;
    END IF;

    err_location := 80;
    IF (LOWER(parm_action) = LOWER('GET_ENTITIES')) THEN
      SELECT mdm_entity_type_id INTO entity_type_id
        FROM mdm_entity_types WHERE LOWER(mdm_entity_type) = LOWER(parm_entity_type);

      mdm_getDecryptTtCols(entity_type_id,tt_curs);
      FETCH tt_curs INTO tt_columns;

      strSQL := 'SELECT mdm_staging_id,mdm_entity_id,mdm_src_sys_id,mdm_src_sys_rec_id,mdm_language_id,
                        mdm_entity_cluster_id,mdm_survivor,mdm_valid_from_dttm,mdm_valid_to_dttm'||tt_columns||' '||
                   'FROM mdm_'||parm_entity_type||'_tt
                  WHERE mdm_valid_to_dttm <= :1';
      OPEN returnCursor FOR strSQL using parm_curr_dttm;
    END IF;

    IF (LOWER(parm_action) = LOWER('DELETE')) THEN
      err_location := 90;
      strSQL := 'DELETE  FROM mdm_'||parm_entity_type||'_al
                  WHERE modified_dttm <= :1';
      EXECUTE IMMEDIATE strSQL using parm_curr_dttm;

      err_location := 100;
      strSQL := 'DELETE FROM mdm_cluster_member_history hist
                  WHERE EXISTS (SELECT 1 FROM mdm_'||parm_entity_type||'_tt tt
                                  WHERE tt.mdm_valid_to_dttm <= :1
                                    AND hist.mdm_entity_id = tt.mdm_entity_id)';
      EXECUTE IMMEDIATE strSQL using parm_curr_dttm;

      strSQL := 'DELETE FROM mdm_cluster_member_history
						      WHERE EXISTS (SELECT mdm_entity_cluster_id 
										     FROM (SELECT mdm_entity_cluster_id,mdm_valid_to_dttm,
												     MAX(NVL(mdm_valid_to_dttm,TO_DATE(''31.12.9999 23:59:59'', ''dd.mm.yyyy hh24:mi:ss'')))
                                                 OVER (PARTITION BY mdm_entity_cluster_id) max_valid_to_dttm
											    FROM (SELECT mdm_entity_cluster_id,mdm_valid_to_dttm FROM mdm_'||parm_entity_type||'_tt 
													   WHERE mdm_survivor=''Y''
						                  AND (mdm_valid_to_dttm IS NULL OR mdm_valid_to_dttm <= :1)) tmp) tmp1
									   WHERE mdm_valid_to_dttm IS NOT NULL AND mdm_valid_to_dttm = max_valid_to_dttm
								         AND mdm_cluster_member_history.mdm_entity_cluster_id = mdm_entity_cluster_id)';
      EXECUTE IMMEDIATE strSQL using parm_curr_dttm;

      err_location := 110;
      strSQL := 'DELETE FROM mdm_entity_rel rel
                  WHERE EXISTS (SELECT 1 FROM
                                (SELECT DISTINCT rel1.mdm_from_cluster_id, rel1.mdm_to_cluster_id
                                   FROM mdm_entity_rel rel1, mdm_'||parm_entity_type||'_tt tt
                                  WHERE rel1.mdm_valid_to_dttm <= :1
                                    AND rel1.mdm_valid_from_dttm <> rel1.mdm_valid_to_dttm
                                    AND (tt.mdm_entity_cluster_id = rel1.mdm_from_cluster_id OR tt.mdm_entity_cluster_id = rel1.mdm_to_cluster_id)) tmp
                              WHERE rel.mdm_from_cluster_id = tmp.mdm_from_cluster_id
                                AND rel.mdm_to_cluster_id = tmp.mdm_to_cluster_id)';
      EXECUTE IMMEDIATE strSQL using parm_curr_dttm;

      err_location := 120;
      strSQL := 'DELETE FROM mdm_cluster_mapping
						WHERE EXISTS (SELECT mdm_entity_cluster_id 
										FROM (SELECT mdm_entity_cluster_id,mdm_valid_to_dttm,
												     MAX(NVL(mdm_valid_to_dttm,TO_DATE(''31.12.9999 23:59:59'', ''dd.mm.yyyy hh24:mi:ss'')))
                                                 OVER (PARTITION BY mdm_entity_cluster_id) max_valid_to_dttm
											    FROM (SELECT mdm_entity_cluster_id,mdm_valid_to_dttm FROM mdm_'||parm_entity_type||'_tt 
													   WHERE mdm_survivor=''Y''
						                         AND (mdm_valid_to_dttm IS NULL OR mdm_valid_to_dttm <= :1)) tmp) tmp1
									   WHERE mdm_valid_to_dttm IS NOT NULL AND mdm_valid_to_dttm = max_valid_to_dttm
								         AND (mdm_cluster_mapping.original_cluster_id = mdm_entity_cluster_id
											  OR mdm_cluster_mapping.current_cluster_id = mdm_entity_cluster_id))';
      EXECUTE IMMEDIATE strSQL using parm_curr_dttm;

      err_location := 130;
      strSQL := 'DELETE FROM mdm_entity_clusters
						WHERE EXISTS (SELECT mdm_entity_cluster_id 
										FROM (SELECT mdm_entity_cluster_id,mdm_valid_to_dttm,
												     MAX(NVL(mdm_valid_to_dttm,TO_DATE(''31.12.9999 23:59:59'', ''dd.mm.yyyy hh24:mi:ss'')))
                                                 OVER (PARTITION BY mdm_entity_cluster_id) max_valid_to_dttm
											    FROM (SELECT mdm_entity_cluster_id,mdm_valid_to_dttm FROM mdm_'||parm_entity_type||'_tt 
													   WHERE mdm_survivor=''Y''
						                         AND (mdm_valid_to_dttm IS NULL OR mdm_valid_to_dttm <= :1)) tmp) tmp1
									   WHERE mdm_valid_to_dttm IS NOT NULL AND mdm_valid_to_dttm = max_valid_to_dttm
								         AND mdm_entity_clusters.mdm_entity_cluster_id = mdm_entity_cluster_id)';
      EXECUTE IMMEDIATE strSQL using parm_curr_dttm;

      err_location := 140;
      strSQL := 'DELETE FROM mdm_'||parm_entity_type||'_tt
                  WHERE mdm_valid_to_dttm <= :1';
      EXECUTE IMMEDIATE strSQL using parm_curr_dttm;
      COMMIT;

      OPEN returnCursor FOR SELECT 'Y' AS process_complete FROM DUAL;
    END IF;

  EXCEPTION
  WHEN OTHERS THEN
    ROLLBACK;
    mdm_log_error(parm_entity_type,null,0,null,'mdm_getArchivalCounts',SQLCODE,'Location:'||err_location||':'||SQLERRM,systimestamp);
    RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;
  
  PROCEDURE mdm_alterTtIndices (parm_entity_type IN VARCHAR2, 
                                parm_index_option IN VARCHAR2) AS
                                
    err_location INTEGER;
    indexName    VARCHAR2(50);
    CURSOR get_ttIndices IS SELECT index_name FROM user_indexes
             WHERE LOWER(table_name) = LOWER('MDM_'||parm_entity_type||'_TT')
               AND LOWER(index_name) LIKE LOWER('IDT_'||parm_entity_type||'_%');    
  BEGIN
    err_location := 10;    
    OPEN get_ttIndices;
      LOOP
        FETCH get_ttIndices INTO indexName;
        EXIT WHEN get_ttIndices%NOTFOUND;
        EXECUTE IMMEDIATE 'ALTER INDEX '||indexName||' '||parm_index_option;
    END LOOP;
    CLOSE get_ttIndices;
  
  EXCEPTION
  WHEN OTHERS THEN
    ROLLBACK;
    mdm_log_error(parm_entity_type,null,0,null,'mdm_getArchivalCounts',SQLCODE,'Location:'||err_location||':'||SQLERRM,systimestamp);
    RAISE_APPLICATION_ERROR(-20000,SQLERRM);
  END;
END MD;
/
show errors
/

prompt Creating triggers
prompt =============================
create or replace trigger mdm_attrs_bi
  before insert on mdm_attrs
  for each row
begin
  IF :new.mdm_attr_id IS NULL THEN
    SELECT mdm_attrs_seq.nextval INTO :new.mdm_attr_id FROM DUAL;
  END IF;
end mdm_attrs_bi;
/

create or replace trigger mdm_attr_profiles_bi
  before insert on mdm_attr_profiles
  for each row
begin
  IF :new.mdm_attr_profile_id IS NULL THEN
    SELECT mdm_attr_profiles_seq.nextval INTO :new.mdm_attr_profile_id FROM DUAL;
  END IF;
end mdm_attr_profiles_bi;
/

create or replace trigger MDM_ATTR_DATATYPES_bi
  before insert on MDM_ATTR_DATATYPES
  for each row
begin
  IF :new.MDM_ATTR_DATATYPE_id IS NULL THEN
    SELECT MDM_ATTR_DATATYPES_seq.nextval INTO :new.MDM_ATTR_DATATYPE_id FROM DUAL;
  END IF;
end MDM_ATTR_DATATYPES_bi;
/

create or replace trigger MDM_ATTR_ACCESS_BI
  before insert on MDM_ATTR_ACCESS
  for each row
begin
  IF :new.MDM_ATTR_GROUP_ID IS NULL THEN
    SELECT MDM_ATTR_GROUPS_SEQ.nextval INTO :new.MDM_ATTR_GROUP_ID FROM DUAL;
  END IF;
end MDM_ATTR_ACCESS_BI;
/

create or replace trigger MDM_ERROR_LOG_BI
  before insert on MDM_ERROR_LOG
  for each row
begin
  IF :new.MDM_ERROR_LOG_ID IS NULL THEN
    SELECT MDM_ERROR_LOG_seq.nextval INTO :new.MDM_ERROR_LOG_ID FROM DUAL;
  END IF;
end MDM_ERROR_LOG_BI;
/

create or replace trigger MDM_ENTITY_TYPES_bi
  before insert on MDM_ENTITY_TYPES
  for each row
begin
  IF :new.MDM_ENTITY_TYPE_id IS NULL THEN
    SELECT MDM_ENTITY_TYPES_seq.nextval INTO :new.MDM_ENTITY_TYPE_id FROM DUAL;      
  END IF;  
end MDM_ENTITY_TYPES_bi;
/

create or replace trigger MDM_ENTITY_TYPES_bu
  before update on MDM_ENTITY_TYPES
  for each row
begin
  SELECT systimestamp INTO :new.MDM_LAST_MOD_DTTM FROM DUAL;
end MDM_ENTITY_TYPES_bu;
/

create or replace trigger MDM_ENTITY_ACCESS_BI
  before insert on MDM_ENTITY_TYPE_ACCESS
  for each row
begin
  IF :new.MDM_ENTITY_GROUP_ID IS NULL THEN
    SELECT MDM_ENTITY_GROUPS_SEQ.nextval INTO :new.MDM_ENTITY_GROUP_ID FROM DUAL;
  END IF;
end MDM_ENTITY_ACCESS_BI;
/

create or replace trigger MDM_SRC_SYS_bi
  before insert on MDM_SRC_SYS
  for each row
begin
  IF :new.MDM_SRC_SYS_id IS NULL THEN
    SELECT MDM_SRC_SYS_seq.nextval INTO :new.MDM_SRC_SYS_id FROM DUAL;
  END IF;
end MDM_SRC_SYS_bi;
/

CREATE OR REPLACE TRIGGER mdm_languages_bi
  BEFORE INSERT ON mdm_languages
  FOR EACH ROW
BEGIN
  IF :new.mdm_language_id IS NULL THEN
    SELECT mdm_languages_seq.nextval INTO :new.mdm_language_id FROM DUAL;
  END IF;
END mdm_languages_bi;
/

CREATE OR REPLACE TRIGGER mdm_process_control_bi
  BEFORE INSERT ON mdm_process_control
  FOR EACH ROW
BEGIN
  IF :new.process_id IS NULL THEN
    SELECT mdm_process_control_seq.nextval INTO :new.process_id FROM dual;
  END IF;
END mdm_process_control_bi;
/

CREATE OR REPLACE TRIGGER mdm_cluster_conditions_bi
  BEFORE INSERT ON mdm_cluster_conditions
  FOR EACH ROW
BEGIN
  IF :new.mdm_cluster_condition_id IS NULL OR :new.mdm_cluster_condition_id=0 THEN
    SELECT MDM_CLUSTER_CONDITIONS_SEQ.nextval INTO :new.mdm_cluster_condition_id FROM dual;
  END IF;
END mdm_cluster_conditions_bi;
/

CREATE OR REPLACE TRIGGER mdm_entity_rel_types_bi
  BEFORE INSERT ON mdm_entity_rel_types
  FOR EACH ROW
BEGIN
  IF :new.mdm_rel_type_id IS NULL OR :new.mdm_rel_type_id=0 THEN
    SELECT MDM_ENTITY_REL_TYPES_SEQ.nextval INTO :new.mdm_rel_type_id FROM dual;
  END IF;
END mdm_entity_rel_types_bi;
/

show errors
spool off
exit
